#include "3dchild.h"

dreidchild::dreidchild(TMDIClient& parent, TPalette* Palette_fuer_alle) : TMDIChild(parent) {
	_proportional=false;
	Palette=Palette_fuer_alle;
	_Palette_benutzen=(Palette_fuer_alle!=0);

}
////////////////////////////////////////////////////////////////////////////////
void dreidchild::berechne_Grenzen(FTyp& von,FTyp& bis,FTyp& mag) {

	// berechnet Grenzen fr die in dem Bereich zu beschriftenden Werte
	FTyp dx=bis-von;
	FTyp step = log10(dx);

	step = floor(step)-mag;
	step = pow10(step);

	von /= step;
	if (von < 0.0)
		von = ceil(von);
	else
		von = floor(von);


	bis /= step;

	if (bis < 0.0)
		bis = ceil(bis);
	else
		bis = floor(bis);

}
////////////////////////////////////////////////////////////////////////////////
FTyp dreidchild::berechne_Schrittweite(FTyp& von,FTyp& bis) {

	// wird zur Bestimmung der Schrittweiten verwendet

	FTyp dx=bis-von;
	FTyp step = log10(dx);
	step = floor(step);
	return step;
}
////////////////////////////////////////////////////////////////////////////////
int dreidchild::berechne_modulo(FTyp von,FTyp bis) {

	// berechnet die grobe Schrittweite zur Beschriftung der Achsen

	von = bis- von;

	if (von < 5)
		return 1;
	if (von < 10)
		return 2;
	if (von < 20)
		return 5;
	if (von < 50)
		return 10;
	return 20;
}
int dreidchild::berechne_modulo2(int von) {

	// berechnet die feine Schrittweite zur Beschriftung der Achsen

	if (von==20)
		return 10;

	if (von==10)
		return 5;

	if (von==5)
		return 1;

	if (von==2)
		return 1;
	return 1;
}
////////////////////////////////////////////////////////////////////////////////
void dreidchild::male_Achsen(TDC& mydc) {

	// projiziert und malt die Achsen ("hinten" und "unten")

	char s[16];
	FTyp xe1,ye1,xe2,ye2;
	FTyp von,bis,von2,bis2,step,count,breite,scale;
	int mo,mo2;

	mydc.SelectStockObject(BLACK_PEN);
	TPoint punkte[4];

	mydc.SelectObject(*_Schrift);
	mydc.SetTextAlign(TA_RIGHT | TA_BASELINE);

	// Y-Achse
	projiziere(xmax,ymin,zmax,xe1,ye1);
	projiziere(xmax,ymax,zmax,xe2,ye2);

	mydc.MoveTo(xe1,ye1);
	mydc.LineTo(xe2,ye2);


	// Schrittweite fr Striche bestimmen
	von=von2=ymin;
	bis=bis2=ymax;
	breite=(zmax-zmin)/20;

	step=(berechne_Schrittweite(von,bis));

	berechne_Grenzen(von,bis,0);
	berechne_Grenzen(von2,bis2,1);

	scale=pow10(step);
	if (von==bis) {
		von=von2;
		bis=bis2;
		scale/=10;
	}

	mo = berechne_modulo(von,bis);
	mo2 = berechne_modulo2(mo);

	// Striche malen
	for (count=von; count <= bis; count++) {
			if (((int)count%mo)!=0) {
				if (((int)count%mo2)==0) {
					projiziere(xmin,count*scale,zmin-breite/4,xe1,ye1);
					projiziere(xmin,count*scale,zmin+breite/4,xe2,ye2);
					mydc.MoveTo(xe1,ye1);
					mydc.LineTo(xe2,ye2);
				}
			}
			else {
				projiziere(xmin,count*scale,zmin-breite/2,xe1,ye1);
				projiziere(xmin,count*scale,zmin+breite/2,xe2,ye2);
				mydc.MoveTo(xe1,ye1);
				mydc.LineTo(xe2,ye2);
				// beschriften
				sprintf(s,"%.2g",count*scale);
				mydc.TextOut(xe1,ye1,s,strlen(s));
			}
	}

	// Name der Ausgabevariablen ausgeben
	projiziere(xmin,ymax ,zmax,xe1,ye1);

	mydc.SetTextAlign(TA_CENTER | TA_BASELINE);
	mydc.TextOut(xe1,ye1-4,
				_stellgroesse_name.c_str(),strlen(_stellgroesse_name.c_str()));

	// Rest Y-Achse
	projiziere(xmin,ymin,zmin,xe1,ye1);
	projiziere(xmin,ymax,zmin,xe2,ye2);

	mydc.MoveTo(xe1,ye1);
	mydc.LineTo(xe2,ye2);


	projiziere(xmin,ymin,zmax,xe1,ye1);
	projiziere(xmin,ymax,zmax,xe2,ye2);

	mydc.MoveTo(xe1,ye1);
	mydc.LineTo(xe2,ye2);


	// X-Achse
	projiziere(xmin,ymin,zmin,xe1,ye1);
	projiziere(xmax,ymin,zmin,xe2,ye2);

	mydc.MoveTo(xe1,ye1);
	mydc.LineTo(xe2,ye2);

	// Schrittweite fr Striche bestimmen
	von=von2=xmin;
	bis=bis2=xmax;
	breite=(zmax-zmin)/20;

	step=(berechne_Schrittweite(von,bis));

	berechne_Grenzen(von,bis,0);
	berechne_Grenzen(von2,bis2,1);

	mydc.SetTextAlign(TA_RIGHT | TA_TOP);

	scale=pow10(step);

	if (von==bis) {
		von=von2;
		bis=bis2;
		scale/=10;
	}

	mo = berechne_modulo(von,bis);
	mo2 = berechne_modulo2(mo);

	// Striche malen
	for (count=von; count <= bis; count++) {
			if (((int)count%mo)!=0) {
				if (((int)count%mo2)==0) {
					projiziere(count*scale,ymin,zmin-breite/4,xe1,ye1);
					projiziere(count*scale,ymin,zmin+breite/4,xe2,ye2);
					mydc.MoveTo(xe1,ye1);
					mydc.LineTo(xe2,ye2);
				}
			}
			else {
				projiziere(count*scale,ymin,zmin-breite/2,xe1,ye1);
				projiziere(count*scale,ymin,zmin+breite/2,xe2,ye2);
				mydc.MoveTo(xe1,ye1);
				mydc.LineTo(xe2,ye2);
				// beschriften
				sprintf(s,"%.2g",count*scale);
				mydc.TextOut(xe1-3,ye1,s,strlen(s));
			}
	}

	// Name der ersten Variablen ausgeben
	projiziere(xmin+(xmax-xmin)/2,ymin,zmin-breite/2,xe1,ye1);
	projiziere(xmin				  ,ymin,zmin-breite/2,xe2,ye2);

	mydc.SetTextAlign(TA_CENTER | TA_TOP);
	mydc.TextOut(xe2,ye1,_Var1.c_str(),_Var1.length());


	// Rest X-Achse
	projiziere(xmin,ymin,zmax,xe1,ye1);
	projiziere(xmax,ymin,zmax,xe2,ye2);

	mydc.MoveTo(xe1,ye1);
	mydc.LineTo(xe2,ye2);

	projiziere(xmin,ymax,zmax,xe1,ye1);
	projiziere(xmax,ymax,zmax,xe2,ye2);

	mydc.MoveTo(xe1,ye1);
	mydc.LineTo(xe2,ye2);


	//---------------------------------------------------------------------------

	// Z-Achse

	projiziere(xmax,ymin,zmin,xe1,ye1);
	projiziere(xmax,ymin,zmax,xe2,ye2);

	mydc.MoveTo(xe1,ye1);
	mydc.LineTo(xe2,ye2);

	// Schrittweite fr Striche bestimmen
	von=von2=zmin;
	bis=bis2=zmax;
	breite=(xmax-xmin)/20;

	step=(berechne_Schrittweite(von,bis));

	berechne_Grenzen(von,bis,0);
	berechne_Grenzen(von2,bis2,1);

	mydc.SetTextAlign(TA_TOP | TA_LEFT);

	scale=pow10(step);

	if (von==bis) {
		von=von2;
		bis=bis2;
		scale/=10;
	}

	mo  = berechne_modulo(von,bis);
	mo2 = berechne_modulo2(mo);

	// Striche malen
	for (count=von; count <= bis; count++) {
			if (((int)count%mo)!=0) {
				if (((int)count%mo2)==0) {
					projiziere(xmax-breite/4,ymin,count*scale,xe1,ye1);
					projiziere(xmax+breite/4,ymin,count*scale,xe2,ye2);
					mydc.MoveTo(xe1,ye1);
					mydc.LineTo(xe2,ye2);
				}
			}
			else {
				projiziere(xmax-breite/2,ymin,count*scale,xe1,ye1);
				projiziere(xmax+breite/2,ymin,count*scale,xe2,ye2);
				mydc.MoveTo(xe1,ye1);
				mydc.LineTo(xe2,ye2);
				// beschriften
				sprintf(s,"%.2g",count*scale);
				mydc.TextOut(xe2,ye2,s,strlen(s));
			}

	}

	projiziere(xmax+breite/2,ymin,zmin+(zmax-zmin)/2,xe1,ye1);
	projiziere(xmax+breite/2,ymin,zmax					,xe2,ye2);

	// Name der zweiten Variablen ausgeben
	mydc.SetTextAlign(TA_CENTER | TA_TOP);
	mydc.TextOut(xe2,ye1,_Var2.c_str(),_Var2.length());

	// Rest Z-Achse
	projiziere(xmin,ymax,zmin,xe1,ye1);
	projiziere(xmin,ymax,zmax,xe2,ye2);

	mydc.MoveTo(xe1,ye1);
	mydc.LineTo(xe2,ye2);

	projiziere(xmin,ymin,zmin,xe1,ye1);
	projiziere(xmin,ymin,zmax,xe2,ye2);

	mydc.MoveTo(xe1,ye1);
	mydc.LineTo(xe2,ye2);
}

void dreidchild::male_restliche_Achsen(TDC& mydc) {

	// malt die restlichen Achsen ("vorne" und "oben")

	FTyp xe1,ye1,xe2,ye2;
	mydc.SelectObject(TPen(TColor::Black, 1));
	mydc.SelectObject(TBrush(TColor::White));

	// X-Achse
	projiziere(xmin,ymax,zmin,xe1,ye1);

	projiziere(xmax,ymax,zmin,xe2,ye2);

	mydc.MoveTo(xe1,ye1);
	mydc.LineTo(xe2,ye2);

	// Y-Achse
	projiziere(xmax,ymin,zmin,xe1,ye1);
	projiziere(xmax,ymax,zmin,xe2,ye2);

	mydc.MoveTo(xe1,ye1);
	mydc.LineTo(xe2,ye2);

	// Z-Achse
	projiziere(xmax,ymax,zmin,xe1,ye1);

	projiziere(xmax,ymax,zmax,xe2,ye2);

	mydc.MoveTo(xe1,ye1);
	mydc.LineTo(xe2,ye2);

}

void dreidchild::projiziere(const FTyp& x,const FTyp& y,const FTyp& z,
												FTyp& xe, FTyp& ye) {

	// projiziert einen Punkt
	// der verwendete Algorithmus ist in der Arbeit beschrieben

	xt=sx*(x+tx); // Skalierung und Translation;
	yt=sy*(y+ty);
	zt=sz*(z+tz);

	xt2=xt*a+yt*b+zt*c; // Rotation
	yt2=xt*d+yt*e+zt*f;
	zt2=xt*g+yt*h+zt*i;

	zwis= zt2 - bz;  // Projektion
	xe=tex+(bx-bz*(xt2-bx)/zwis);
	ye=tey-(by-bz*(yt2-by)/zwis);
}

void dreidchild::Konstante_berechnen() {

	// berechnet die fr die Projektion hilfreichen Konstanten

	// Rotation
	rx=45;
	ry=-45;
	rz=0;

	// Beobachter
	bx=0;
	by=-0;
	bz=-1000;

	// Lichtquelle
	lqx=0;
	lqy=-10000;
	lqz=-1000;

	// Translation
	tx=-xmin-(xmax-xmin)/2;
	tz=-zmin-(zmax-zmin)/2;

	// Konstante fr Transformationsmatrix
	rx=rx*M_PI/180;
	ry=ry*M_PI/180;
	rz=rz*M_PI/180;
	six=sin(rx);
	cox=cos(rx);
	siy=sin(ry);
	coy=cos(ry);
	siz=sin(rz);
	coz=cos(rz);
	a=coy*coz;
	b=coy*siz;
	c=-siy;
	d=six*siy*coz-cox*siz;
	e=six*siy*siz+cox*coz;
	f=six*coy;
	g=cox*siy*coz+six*siz;
	h=cox*siy*siz-six*coz;
	i=cox*coy;
}
void dreidchild::neu_skalieren(FTyp& dx,FTyp& dy) {

	// Ebenentranslation
	tex=dx/2;
	tey=dy/2;

	if (dx < dy) {
		sx=dx/(xmax-xmin);
		sy=dx/(ymax-ymin);
		sz=dx/(zmax-zmin);
	}
	else {
		sx=dy/(xmax-xmin);
		sy=dy/(ymax-ymin);
		sz=dy/(zmax-zmin);
	}

	// Skalierung
	sx/=2;
	sz/=2;
	sy/=2;

	// eine Ausgabe, bei der die Achsen mastabsgetreu abgebildet werden
	// ist mglich, wird jedoch nicht verwendet

	if (_proportional) {
		FTyp Dx,Dy,Dz,best;

		Dx=xmax-xmin;
		Dy=ymax-ymin;
		Dz=zmax-zmin;

		if (Dx<0)
			Dx*=-1;
		if (Dy<0)
			Dy*=-1;
		if (Dz<0)
			Dz*=-1;

		if (Dx >= Dy && Dx >= Dz) {
			sy*=Dy/Dx;
			sz*=Dz/Dx;
		}
		if (Dy >= Dx && Dy >= Dz) {
			sx*=Dx/Dy;
			sz*=Dz/Dy;
		}

		if (Dz >= Dy && Dz >= Dx) {
			sy*=Dy/Dz;
			sx*=Dx/Dz;
		}
	}

	ty=-ymin-(ymax-ymin)/2;
}

void dreidchild::SetupWindow() {
	TMDIChild::SetupWindow();

	// Schrift fr die Achsen
	_Schrift= new TFont("Arial",14);

}
dreidchild::~dreidchild() {

	// Schrift freigeben
	delete _Schrift;

}
