#include "activity.h"

TActivityChild::TActivityChild(TMDIClient& parent, TPalette* Palette,
										FController* Test, bool Fehler):
	TSurfaceMDIChild (parent,Palette, Test , Fehler) {
	_Farbschema=orange;
	_mitGitter=true;
}

bool TActivityChild::check_Kennfeld() {
	FTyp y;

	if (!buffer_aktuell) {

		if (!_Controller->Auswertung_vorbereiten()) {

			// falls bei der Vorbereitung ein Fehler aufgetreten ist, abbrechen
			ymin=ymax=0;
			MessageBox(_Controller->hol_Fehlermeldung().c_str(),"Error",  MB_OK | MB_ICONSTOP);
			for (FTyp xc(0); xc<=steps; ++xc)
				for (FTyp zc(0); zc<=steps; ++zc)
					_KennfeldPuffer->buffer[(int)xc][(int)zc]=0;
		}
		else {

		Regelbasis* Basis;

		// Regelbasis holen
		if (_Fehler)
			Basis=&_Controller->hol_FehlerRegelbasis();
		else
			Basis=&_Controller->hol_SteuerRegelbasis();

		// Wartebox zeichnen
		Parent->SetCursor(0,IDC_WAIT);
		TWarteBox warte(this,DIALOG_WARTE,"calculating...",TColor::LtRed);
		warte.Create();
		warte.Show(SW_SHOW);

		// Array berechnen
		FTyp zwert;
		int zci,xci;
		xci=0;
		for (FTyp xc(0); xc<=steps; ++xc,++xci) {

			Var1->setze_Eingabewert(min(xmin+stepx*xc,xmax));

			zwert=zmin;
			zci=0;
			for (FTyp zc(0); zc<=steps; ++zc,zwert+=stepz,++zci ) {

				Var2->setze_Eingabewert(min(zwert,zmax));

				y=Basis->Regelaktivitaet_bestimmen();

				// Minimum und Maximum von y ber das Array bestimmen
				if(xc==0 && zc==0)
					ymax=ymin=y;
				else  {
					if (y<ymin) {
						ymin=y;
					}
					if (y>ymax) {
						ymax=y;
					}
				}

				_KennfeldPuffer->buffer[xci][zci]=y;

			}

			// Wartebox aktualisieren
			if (!(xci % 2))
				warte.SetValue((xc+1)/steps*100);
		}


		// Wartebox schlieen

		warte.CloseWindow();

		Parent->SetCursor(0,IDC_ARROW);

		}


		// Abfrage, ob alle Arrayeintrge identisch

		if (ymin==ymax) {

			if (ymin==0) {

				ymax=1;

				ymin=-1;

			}

			else {

				FTyp dy;

				if (ymin<0)

					dy=-ymin;

				else

					dy=ymin;


				ymin-=dy;

				ymax+=dy;

			}

		}


		// Schattierungen berechnen

		berechne_Schattierungen();

		buffer_aktuell=true;
		_dxalt=0;

		return true;
	}

	return false;

}



void TActivityChild::Paint (TDC& paintdc, BOOL, TRect& ){

	FTyp xe1,ye1,xe2,ye2;

	TRect groesse=GetClientRect();
	TClientDC mydc(*this);

	// Falls kein Echtfarbmodus, Palette benutzen
	if (_Palette_benutzen) {
		mydc.SelectObject(*_Palette);
	}

	// zu zeichnende Bereiche der Variablen holen
	xmin=Var1->min_holen();
	xmax=Var1->max_holen();

	zmin=Var2->min_holen();
	zmax=Var2->max_holen();

	// wurden sie gendert ?
	bool result0=(xmin != xmin_alt) || (xmax != xmax_alt) ||

						(zmin != zmin_alt) || (zmax != zmax_alt) ;

	// falls ja, neu berechnen
	if (result0) {
		zmin_alt=zmin;
		zmax_alt=zmax;
		xmin_alt=xmin;
		xmax_alt=xmax;
		buffer_aktuell=false;
		_dxalt=_dyalt=0;
		stepx=(xmax-xmin)/steps;
		stepz=(zmax-zmin)/steps;
	}

	// haben sich die Namen der Variablen gendert ?
	bool result3=(Var1->Name()!=_Var1) || (Var2->Name()!=_Var2);

	if (result3) {

		// falls ja, neuen Titel konstruieren
		_Var1=Var1->Name();
		_Var2=Var2->Name();
		mystring Titel("Active rules - ");
		if (_Fehler)
			Titel+=_Controller->FehlerVar_holen();
		else
			Titel+=_Controller->AusgabeVar_holen();

		_stellgroesse_name="active rules";
		SetCaption(Titel.c_str());
	}

	// berprfen, ob das Array und die Projektion noch aktuell sind
	bool result1=check_Kennfeld();
	bool result2=check_Projektion(groesse);

	// alles noch aktuell ?
	if (!(result3 || result2 || result1 || result0) && bitmap) {
 
		// falls ja, dann wird nur die bereits gezeichnete Bitmap in das
		// Fenster kopiert

		memDC=new TMemoryDC(mydc);

		if (_Palette_benutzen)
			memDC->SelectObject(*Palette);

		memDC->SelectObject(*bitmap);
		paintdc.BitBlt(0,0, bitmap->Width(), bitmap->Height(),
							*memDC,0,0,SRCCOPY);

		if (_Palette_benutzen)
			memDC->RestorePalette();

		delete memDC;
	}
	else
		// ansonsten mu das Kennfeld neu gezeichnet werden
		Kennfeld_zeichnen(groesse);

}
