#include "contldlg.h"

DEFINE_RESPONSE_TABLE1(TControlDialog, TDialog)
	EV_CHILD_NOTIFY(IDOK, BN_CLICKED, HandleOK),
	EV_CHILD_NOTIFY(IDCANCEL, BN_CLICKED, HandleAbbruch),
END_RESPONSE_TABLE;

TControlDialog::TControlDialog(TWindow* parent, FController* Controller, int Winkel,
								bool Zufall, bool lernen, int Epochen) :
	TDialog (parent,DIALOG_CONTROL),
	_Controller(Controller),
	_Winkel(Winkel), _Zufall(Zufall), _lernen(lernen), _Epochen(Epochen),
	_GroesseBereich(-89,89),
	_EpochenBereich(0,32000),
	_InitBereich(0,90),
	_Eingabe(this,IDC_WINKEL,16),
	_EditEpochen(this,IDC_EPOCHEN,16),

	_EditDelta(this,IDC_DELTA,16),
	_EditDeltaPlus(this,IDC_DELTAPLUS,16),
	_EditDeltaMinus(this,IDC_DELTAMINUS,16),

	_EditStabileEpochen(this,IDC_STABILEEPOCHEN,16),
	_EditStabilerWinkel(this,IDC_STABILERWINKEL,16),
	_EditInstabilerWinkel(this,IDC_INSTABILERWINKEL,16),

	_Verfahren(this,IDC_VERFAHREN,30),
	_EditInit(this,IDC_BEREICH,16),
	_CheckTrace(this,IDC_TRACE),
	_Gruppe(this,IDC_GROUPBOX1),
	_CheckLernen(this,IDC_ADAPTIEREN,&_Gruppe),

	_CheckRegelnLernen(this,IDC_REGELNLERNEN,&_Gruppe),

	_CheckZufall(this,IDC_ZUFALL) {
}

void TControlDialog::SetupWindow() {
	char buf[16];

	TDialog::SetupWindow();

	wsprintf(buf,"%d",_Winkel);
	_Eingabe.SetText((char *)buf);

	wsprintf(buf,"%d",_Controller->InitBereich_holen());
	_EditInit.SetText((char *)buf);


	wsprintf(buf,"%d",_Controller->Epochen_holen());
	_EditEpochen.SetText((char *)buf);
	sprintf(buf,"%.4f",_Controller->delta_holen());
	_EditDelta.SetText((char *)buf);
	sprintf(buf,"%.4f",_Controller->deltaPlus_holen());
	_EditDeltaPlus.SetText((char *)buf);
	sprintf(buf,"%.4f",_Controller->deltaMinus_holen());
	_EditDeltaMinus.SetText((char *)buf);

	sprintf(buf,"%d",(int)_Controller->stabilerWinkel_holen());
	_EditStabilerWinkel.SetText((char *)buf);
	sprintf(buf,"%d",(int)_Controller->instabilerWinkel_holen());
	_EditInstabilerWinkel.SetText((char *)buf);


	wsprintf(buf,"%d",_Controller->stabileEpochen_holen());
	_EditStabileEpochen.SetText((char *)buf);

	_Verfahren.AddString("verschieben");
	_Verfahren.AddString("Fuzzy-Backprop.");
	_Verfahren.AddString("Fuzzy-SuperSAB");
	_Verfahren.AddString("Fuzzy-Delta-Bar-Delta");


	switch (_Controller->Verfahren_holen())  {
		case (fbackprop) : {
			_Verfahren.SetText("Fuzzy-Backprop.");
			break;
		}
		case (fssab) : {
			_Verfahren.SetText("Fuzzy-SuperSAB");
			break;
		}
		case (fdbd) : {
			_Verfahren.SetText("Fuzzy-Delta-Bar-Delta");
			break;
		}
		case (verschieben) : {
			_Verfahren.SetText("verschieben");
			break;
		}


	}
	if (_Controller->trace_holen())
		_CheckTrace.Check();

	if (_Zufall)
		_CheckZufall.Check();

	//if (_lernen)
	//	_CheckLernen.Check();


	TRect parentRect;
	Parent->GetWindowRect(parentRect);

	TRect dlgRect;
	GetWindowRect(dlgRect);

	int xPos = parentRect.Width() / 2- dlgRect.Width() / 2 + parentRect.left;
	int yPos = parentRect.Height() / 2- dlgRect.Height() / 2 + parentRect.top;

	MoveWindow(xPos,yPos,dlgRect.Width(), dlgRect.Height());

}


void TControlDialog::HandleOK() {
	char Wert[16];


	_Eingabe.GetText((char *)&Wert,16);
	if (!_GroesseBereich.IsValid((char *)&Wert) ) {
		MessageBox("-90 < Startwinkel < 90 !","Startwinkel",MB_OK);
		return;
	}
	_Winkel=atoi((char *)&Wert);
	_EditInit.GetText((char *)&Wert,16);
	if (!_InitBereich.IsValid((char *)&Wert) ) {
		MessageBox("0 < Bereich < 90  !","Bereich",MB_OK);
		return;
	}
	_Controller->setze_InitBereich(atoi((char *)&Wert));

	_EditStabileEpochen.GetText((char *)&Wert,16);
	if (!_InitBereich.IsValid((char *)&Wert) ) {
		MessageBox("Epochen > 0 !","Bereich",MB_OK);
		return;
	}
	_Controller->setze_stabileEpochen(atoi((char *)&Wert));



	_EditStabilerWinkel.GetText((char *)&Wert,16);
	if (!_InitBereich.IsValid((char *)&Wert) ) {
		MessageBox("0 < Bereich < 90  !","Bereich",MB_OK);
		return;
	}
	_Controller->setze_stabilerWinkel(atoi((char *)&Wert));

	_EditInstabilerWinkel.GetText((char *)&Wert,16);
	if (!_InitBereich.IsValid((char *)&Wert) ) {
		MessageBox("0 < Bereich < 90  !","Bereich",MB_OK);
		return;
	}
	_Controller->setze_instabilerWinkel(atoi((char *)&Wert));




	_EditEpochen.GetText((char *)&Wert,16);

	if (!_EpochenBereich.IsValid((char *)&Wert) ) {
		MessageBox("Epochen > 0 !","Epochen",MB_OK);
		return;
	}

	_Controller->setze_Epochen(atoi((char *)&Wert));

	_EditDelta.GetText((char *)&Wert,16);
	if (atof((char *)&Wert)< 0) {
		MessageBox("delta > 0 !","delta",MB_OK);
		return;
	}
	_Controller->setze_delta(atof((char *)&Wert));


	_EditDeltaPlus.GetText((char *)&Wert,16);
	if (atof((char *)&Wert)< 0) {
		MessageBox("delta+ > 0 !","delta+",MB_OK);
		return;
	}
	_Controller->setze_deltaPlus(atof((char *)&Wert));

	_EditDeltaMinus.GetText((char *)&Wert,16);
	if (atof((char *)&Wert)< 0) {
		MessageBox("delta- > 0 !","delta+",MB_OK);
		return;
	}
	_Controller->setze_deltaMinus(atof((char *)&Wert));


	_EditDelta.GetText((char *)&Wert,16);
	if (atof((char *)&Wert)< 0) {
		MessageBox("delta > 0 !","delta",MB_OK);
		return;
	}
	_Controller->setze_delta(atof((char *)&Wert));

	_Verfahren.GetText((char *)&Wert,30);
	mystring Eingabe(Wert);

	if (Eingabe=="Fuzzy-Backprop.") {
			_Controller->setze_Verfahren(fbackprop);
	}
	if (Eingabe=="Fuzzy-SuperSAB") {
			_Controller->setze_Verfahren(fssab);
	}
	if (Eingabe=="Fuzzy-Delta-Bar-Delta") {
			_Controller->setze_Verfahren(fdbd);
	}
	if (Eingabe=="verschieben") {
			_Controller->setze_Verfahren(verschieben);
	}





	_Zufall=_CheckZufall.GetCheck();
	_lernen=_CheckLernen.GetCheck();
	_Controller->setze_trace(_CheckTrace.GetCheck());
	_Abbruch=false;
	TDialog::CloseWindow();

}
void TControlDialog::HandleAbbruch() {
	_Abbruch=true;
	TDialog::CloseWindow();
}
