#include "FController.h"


FController::FController(): _EingabeVarListe(), _AusgabeVar(), _FehlerVar(),
  _SteuerRegelbasis(&_EingabeVarListe,&_AusgabeVar),
  _FehlerRegelbasis(&_EingabeVarListe,&_FehlerVar) {

	_Winkel = 45;
	_Zufall = true;

	_delta = 2.0 ;
	_delta_plus=1.25;
	_delta_minus=0.8;

	_Epochen = 500;
	_RegelnEpochen = 500;

	_InitBereich = 45;
	_Verfahren = fssab;
	_stabileEpochen=20;
	_stabilerWinkel=0;
	_instabilerWinkel=90;
	_trace=false;
	_Lernmodus=simulieren;
}
/*
void FController::DurchschnittsOp_setzen(Operator Op) {
	_Op=Op;
	_SteuerRegelbasis.Operator_setzen(_Op);
	_FehlerRegelbasis.Operator_setzen(_Op);

} */


void FController::EingabeVar_hinzufuegen(mystring Name, FTyp& min, FTyp& max) {

  EingabeVariable* temp = new EingabeVariable(Name, min, max);
  _EingabeVarListe.append(temp);

}

void FController::AusgabeVar_setzen(mystring Name, FTyp& min, FTyp& max) {
  AusgabeVariable temp(Name, min, max);
  _AusgabeVar=temp;
}

void FController::FehlerVar_setzen(mystring Name, FTyp& min, FTyp& max) {
  AusgabeVariable temp(Name, min, max);
  _FehlerVar=temp;
}
const mystring& FController::AusgabeVar_holen() {
	return _AusgabeVar.Name();
}
const mystring& FController::FehlerVar_holen() {
	return _FehlerVar.Name();
}

void FController::LingVar_setze_Grenze(mystring& VarName,mystring& Name,
										FTyp x1,FTyp x2) {

	if (VarName==_AusgabeVar.Name())
		_AusgabeVar.LingVar_setze_Grenze(Name,x1,x2);
	else {
		if (VarName==_FehlerVar.Name())
			_FehlerVar.LingVar_setze_Grenze(Name,x1,x2);

		else {

			TEingabeVarlisteIter Iter(_EingabeVarListe);

			bool searching(true);

			while (Iter && searching) {

				searching=(Iter.Current()->Name()!=VarName);

				if (searching)
					Iter++;
			}
			if (!searching)
				(Iter.Current())->LingVar_setze_Grenze(Name,x1,x2);
		}
	}
}


void FController::LingVar_hinzufuegen(mystring& VarName,mystring& Name,
													FTyp x1,FTyp x2) {
	LingVar_hinzufuegen(VarName,Name,x1,x2,0,0);
}

void FController::LingVar_hinzufuegen(mystring& VarName,mystring& Name,
													FTyp x1,FTyp x2, FTyp x3) {
	LingVar_hinzufuegen(VarName,Name,x1,x2,x3,0,0);

}

void FController::LingVar_hinzufuegen(mystring& VarName,mystring& Name,
													FTyp x1,FTyp x2,
													FTyp min_x, FTyp max_x) {

  if (VarName==_AusgabeVar.Name())
	 _AusgabeVar.LingVar_einfuegen(Name,x1,x2,min_x,max_x);
  else
	 if (VarName==_FehlerVar.Name())
		_FehlerVar.LingVar_einfuegen(Name,x1,x2,min_x,max_x);

	 else {

		TEingabeVarlisteIter Iter(_EingabeVarListe);

		bool searching(true);

		while (Iter && searching) {

			searching=(Iter.Current()->Name()!=VarName);

			if (searching)
				Iter++;
		}
		if (!searching)
			(Iter.Current())->LingVar_einfuegen(Name,x1,x2,min_x,max_x);
	 }
}

void FController::Auswertung_vorbereiten() {

		_SteuerRegelbasis.Auswertung_vorbereiten();
		_FehlerRegelbasis.Auswertung_vorbereiten();

}
void FController::Lernen_vorbereiten() {
		_SteuerRegelbasis.Lernen_vorbereiten(_Verfahren, _Epochen,
														_delta,_delta_plus,_delta_minus,
														_stabilerWinkel,_stabileEpochen,
														_instabilerWinkel);
}
void FController::delta_ruecksetzen() {
	_SteuerRegelbasis.delta_ruecksetzen();
}
void FController::LingVar_hinzufuegen(mystring& VarName,mystring& Name,
													FTyp x1, FTyp x2, FTyp x3,
													FTyp min_x, FTyp max_x) {

	if (VarName==_AusgabeVar.Name())
		_AusgabeVar.LingVar_einfuegen(Name,x1,x2,x3,min_x,max_x);
	else {
		TEingabeVarlisteIter Iter(_EingabeVarListe);

		bool searching(true);
		while (Iter && searching) {

			searching=(Iter.Current()->Name()!=VarName);

			if (searching)
				Iter++;
		}

		if (!searching)
			(Iter.Current())->LingVar_einfuegen(Name,x1,x2,x3,min_x,max_x);
	}

}

void FController::SteuerRegel_hinzufuegen(list<mystring>& Praemisse,mystring Konklusion) {

  Regel temp(&_EingabeVarListe,&_AusgabeVar);

  listIter<mystring> Iter(Praemisse);



  while(Iter) {
	temp.Praemisse_hinzufuegen(Iter.Current());
	Iter++;
  }




  temp.Konklusion_setzen(Konklusion);

  _SteuerRegelbasis.Regel_hinzufuegen(temp);

}

void FController::FehlerRegel_hinzufuegen(list<mystring>& Praemisse,mystring Konklusion) {

  Regel temp(&_EingabeVarListe,&_FehlerVar);
  listIter<mystring> Iter(Praemisse);


  while(Iter) {
	temp.Praemisse_hinzufuegen(Iter.Current());
	Iter++;
  }

  temp.Konklusion_setzen(Konklusion);

  _FehlerRegelbasis.Regel_hinzufuegen(temp);
}
/*

FController::SteuerRegelbasis_ausgeben() {
  cout << _SteuerRegelbasis << endl;
}

FController::FehlerRegelbasis_ausgeben() {
  cout << _FehlerRegelbasis << endl;
}
*/

void FController::EingabeVar_setzeWert(mystring& VarName,FTyp& Wert) {

	TEingabeVarlisteIter Iter(_EingabeVarListe);

	bool searching(true);
	while (Iter && searching) {

		searching=(Iter.Current()->Name()!=VarName);

		if (searching)
			Iter++;
	}

	if (!searching)
		(Iter.Current())->setze_Eingabewert(Wert);

}
EingabeVariable* FController::EingabeVar_holen(mystring& VarName) {

	TEingabeVarlisteIter Iter(_EingabeVarListe);

	bool searching(true);
	while (Iter && searching) {

		searching=(Iter.Current()->Name()!=VarName);

		if (searching)
			Iter++;
	}

	if (!searching)
		return Iter.Current();
	else
		return 0;
}

FTyp& FController::Stellwert_berechnen() {
	_Stellwert =  _SteuerRegelbasis.Regeln_auswerten();
	return _Stellwert;
}

FTyp& FController::Fehler_berechnen() {
	_Fehler =  _FehlerRegelbasis.Regeln_auswerten();
	return _Fehler;
}

void FController::Speicher_freigeben() {
	TEingabeVarlisteIter Iter(_EingabeVarListe);

	while (Iter) {
		delete Iter.Current();
		Iter++;
	}
}
FController::~FController() {
	Speicher_freigeben();
}
void FController::adaptieren() {
  _SteuerRegelbasis.adaptieren(_Fehler);
}

ostream& operator << (ostream& os, FController& einController) {

	os << einController._Winkel << " ";
	os << einController._Zufall << " ";

	os << einController._Verfahren << " ";

	os << einController._delta << " ";
	os << einController._delta_plus << " ";
	os << einController._delta_minus << " ";

	os << einController._stabilerWinkel << " ";
	os << einController._instabilerWinkel << " ";

	os << einController._Epochen << " ";
	os << einController._RegelnEpochen << " ";

	os << einController._stabileEpochen << " ";
	os << einController._InitBereich << " ";
	os << einController._trace << endl;



	os << einController._AusgabeVar ;
	os << einController._FehlerVar ;

	TEingabeVarlisteIter Iter(einController._EingabeVarListe);
	os << einController._EingabeVarListe.GetItemsInContainer() << endl;

	while (Iter) {
		os << *Iter.Current() ;
		Iter++;
	}
	os << einController._SteuerRegelbasis << einController._FehlerRegelbasis;
	return os;
}

istream& operator >> (istream& is, FController& einController) {

	is >> einController._Winkel ;
	is >> einController._Zufall ;

	int verf;
	is >> verf;
	einController._Verfahren = verf;

	is >> einController._delta ;
	is >> einController._delta_plus ;
	is >> einController._delta_minus ;

	is >> einController._stabilerWinkel ;
	is >> einController._instabilerWinkel ;

	is >> einController._Epochen ;
	is >> einController._RegelnEpochen ;

	is >> einController._stabileEpochen ;
	is >> einController._InitBereich ;
	is >> einController._trace;



	is >> einController._AusgabeVar ;
	is >> einController._FehlerVar ;

	int zaehler;
	is >> zaehler;

	einController.Speicher_freigeben();
	einController._EingabeVarListe.Flush();

	while (zaehler) {
		EingabeVariable* temp = new EingabeVariable();
		is >> *temp;
		einController._EingabeVarListe.append(temp);
		zaehler--;
	}

	is >> einController._SteuerRegelbasis >> einController._FehlerRegelbasis;

	einController._FehlerRegelbasis.verfuegbare_FuzzySets_markieren();

	return is;
}
