/*
#ifndef _FCONTROLLER_
#define _FCONTROLLER_

#include "metacntl.h"

#include "mystring.h"
#include "mylist.h"
#include "Regelbasis.h"


enum Lernmodus {simulieren=0, Fuzzy_adaptieren, Regeln_lernen};
class FController {

	FTyp _Fehler,_Stellwert;

	Verfahren _Verfahren;
	FTyp _delta,_delta_plus,_delta_minus;
	FTyp _stabilerWinkel, _instabilerWinkel;
	long int _Epochen, _RegelnEpochen;
	int _stabileEpochen;
	int _InitBereich;
	bool _trace;
	Lernmodus _Lernmodus;


	bool _Zufall;
	int _Winkel;

	// MesswerteListe _WinkelListe,_WinkelVListe,_KraftListe,_FehlerListe;
	Regelbasis _SteuerRegelbasis,_FehlerRegelbasis;

	void Speicher_freigeben();

public:



	TEingabeVarliste _EingabeVarListe;
	AusgabeVariable _AusgabeVar,_FehlerVar;

	FController();
	~FController();

	Regelbasis& hol_SteuerRegelbasis() { return _SteuerRegelbasis;};
	Regelbasis& hol_FehlerRegelbasis() { return _FehlerRegelbasis;};


	void EingabeVar_hinzufuegen(mystring Name, FTyp& min, FTyp& max);

	void AusgabeVar_setzen(mystring Name, FTyp& min, FTyp& max);
	void FehlerVar_setzen(mystring Name, FTyp& min, FTyp& max);

	const mystring& AusgabeVar_holen();
	const mystring& FehlerVar_holen();

	void LingVar_hinzufuegen(mystring& VarName,mystring& Name,
									FTyp x1,FTyp x2, FTyp x3);

	void LingVar_setze_Grenze(mystring& VarName,mystring& Name,
										FTyp x1,FTyp x2=0);

	void LingVar_hinzufuegen(mystring& VarName,mystring& Name,
									FTyp x1,FTyp x2);

	void LingVar_hinzufuegen(mystring& VarName,mystring& Name,
									FTyp x1,FTyp x2,
									FTyp min_x, FTyp max_x);
	void LingVar_hinzufuegen(mystring& VarName,mystring& Name,
									FTyp x1,FTyp x2, FTyp x3,
									FTyp min_x, FTyp max_x);

	void SteuerRegel_hinzufuegen(list<mystring>& Praemisse, mystring Konklusion);
	void FehlerRegel_hinzufuegen(list<mystring>& Praemisse, mystring Konklusion);

  // SteuerRegelbasis_ausgeben();
  // FehlerRegelbasis_ausgeben();

	void Auswertung_vorbereiten();
	void Lernen_vorbereiten();
	void delta_ruecksetzen();
	EingabeVariable* EingabeVar_holen(mystring& VarName);
	void EingabeVar_setzeWert(mystring& VarName,FTyp& Wert);

	// void DurchschnittsOp_setzen(Operator Op);

	FTyp& Stellwert_berechnen();
	FTyp& Fehler_berechnen();


	void setze_stabileEpochen(int& Epochen) {_stabileEpochen = Epochen;};
	int stabileEpochen_holen() {return _stabileEpochen;};



	void setze_Verfahren(Verfahren Verf) {_Verfahren = Verf;};
	Verfahren Verfahren_holen() {return _Verfahren;};

	void setze_Lernmodus(Lernmodus Modus) {_Lernmodus = Modus;};
	Lernmodus Lernmodus_holen() {return _Lernmodus;};

	void setze_stabilerWinkel(FTyp& Winkel) {_stabilerWinkel = Winkel;};
	FTyp stabilerWinkel_holen() {return _stabilerWinkel;};

	void setze_instabilerWinkel(FTyp& Winkel) {_instabilerWinkel = Winkel;};
	FTyp instabilerWinkel_holen() {return _instabilerWinkel;};

	void setze_Winkel(int& Winkel) {_Winkel = Winkel;};
	int Winkel_holen() {return _Winkel;};

	void setze_Zufall(bool Zufall) {_Zufall = Zufall;};
	bool Zufall_holen() {return _Zufall;};

	void setze_delta(FTyp& delta) {_delta = delta;};
	FTyp delta_holen() {return _delta;};
	void setze_deltaPlus(FTyp& deltaPlus) {_delta_plus = deltaPlus;};
	FTyp deltaPlus_holen() {return _delta_plus;};
	void setze_deltaMinus(FTyp& deltaMinus) {_delta_minus = deltaMinus;};
	FTyp deltaMinus_holen() {return _delta_minus;};


	void setze_Epochen(long int& Epochen) {_Epochen = Epochen;};
	long int Epochen_holen() {return _Epochen;};

	void setze_RegelnEpochen(long int& RegelnEpochen)
			{_RegelnEpochen = RegelnEpochen;};
	long int RegelnEpochen_holen() {return _RegelnEpochen;};


	void setze_trace(bool trace) {_trace = trace;};
	bool trace_holen() {return _trace;};

	void setze_InitBereich(int InitBereich) {_InitBereich = InitBereich;};
	int InitBereich_holen() {return _InitBereich;};

	void adaptieren();

	// Messwerte protokollieren
	MesswerteListe& WinkelListe_holen() { return _WinkelListe;};
	MesswerteListe& FehlerListe_holen() { return _FehlerListe;};
	MesswerteListe& KraftListe_holen() 	{ return _KraftListe;};
	MesswerteListe& WinkelVListe_holen(){ return _WinkelVListe;};

	friend ostream& operator << (ostream& os, FController& einController);
	friend istream& operator >> (istream& is, FController& einController);

	};
#endif
*/