#ifndef FSINT
#define FSINT
#include <math.h>
#include "ftyp.h"
#include "mystring.h"
#include "owl/dc.h"

class FsInt {
  FTyp _x1,_x2,_m,_b;
  FTyp _minv,_maxv;
  int _links_offen,_rechts_offen;

  bool _SFunktion;

  public:

	FsInt();

	void setze_Intervall(FTyp x1,FTyp x2, int links_offen=0, int rechts_offen=0);

	bool ist_SFunktion() { return _SFunktion;};
	void setze_SFunktion(bool S) { _SFunktion = S;};

	inline FTyp x1() { return _x1;};
	inline FTyp x2() { return _x2;};
	FTyp& minv() {return _minv;};
	FTyp& maxv() {return _maxv;};

	FTyp x_wert(FTyp& y) const;
	FTyp y_wert(FTyp& x) const;
	inline bool enthalten(FTyp& x) const;

	void skalieren(FTyp& Faktor);
	void setze_Grenze(FTyp& minv, FTyp& maxv) { _minv = minv ; _maxv=maxv;};

	bool enthaelt_Teilmenge_von(FTyp x1,FTyp x2);

	void verschieben(FTyp delta_x);
	bool verschiebbar(FTyp delta_x,FTyp min,FTyp max);
	bool steigend();

	void verschiebe_links(FTyp delta_x);
	bool links_verschiebbar(FTyp delta_x,FTyp min,FTyp max);

	void verschiebe_rechts(FTyp delta_x);
	bool rechts_verschiebbar(FTyp delta_x,FTyp min,FTyp max);

	void malen(TDC& dc,mystring& Name, TRect& viereck,FTyp& min,FTyp& max, TColor Farbe, bool istFehler);


	friend ostream& operator << (ostream& os, FsInt& einFsInt);
	friend istream& operator >> (istream& is, FsInt& einFsInt);

};

inline bool FsInt::enthalten(FTyp& x) const {

	// bestimmt, ob der x-Wert in dem gegebenen Intervall enthalten ist

	if (x==_x1 && _links_offen)
		return 0;
	if (x==_x2 && _rechts_offen)
		return 0;
	if (_x1 <= _x2)
		return (x>= _x1 && x <=_x2);
	else
		return (x>= _x2 && x <=_x1);
}
#endif
