#ifndef _FSSET_
#define _FSSET_

#include "mystring.h"
#include "fsint.h"
#include <owl/dc.h>

class FsSet {

  mystring _Name;
  bool _SFunktion;

  protected:
	int _Anzahl_Intervalle;
	FsInt _Intervall1,_Intervall2;
	FTyp _min_x,_max_x,_Aktivierung,_verantwortliches_Intervall;
	FTyp _minv,_maxv;

public:
	bool _fuer_Regel_verfuegbar;

	FTyp _letzter_xwert;

	FsSet();
	FsSet(mystring& Name);

	mystring Name();

	int Anzahl_Intervalle();

	bool ist_SFunktion() { return _SFunktion;};
	void setze_SFunktion(bool S);

	FTyp x1();
	FTyp x2();
	FTyp x3();

	FTyp minv1() { return _Intervall1.minv();};
	FTyp maxv1() { return _Intervall1.maxv();};

	FTyp minv2() { return _Intervall2.minv();};
	FTyp maxv2() { return _Intervall2.maxv();};


	int Intervall_einfuegen(FTyp x1,FTyp x2,FTyp min_x,FTyp max_x);
	int Intervall_einfuegen(FTyp x1,FTyp x2,FTyp x3,FTyp min_x,FTyp max_x);

	void setze_Grenze(FTyp x1, FTyp x2);
	void skalieren(FTyp& Faktor);

	void verschieben(FTyp delta_x);
	bool verschiebbar(FTyp delta_x);
	bool verschiebbar_mit_Restriktionen(FTyp& delta_x);

	void verschiebe_links(FTyp delta_x);
	bool links_verschiebbar(FTyp delta_x);

	void verschiebe_rechts(FTyp delta_x);
	bool rechts_verschiebbar(FTyp delta_x);

	inline FTyp y_wert(FTyp& x);
	FTyp x_wert(FTyp& y) const;

	inline bool enthalten(FTyp& x);
	inline bool links_enthalten(FTyp& x);
	inline bool rechts_enthalten(FTyp& x);

	bool enthaelt_Teilmenge_von(FTyp x1,FTyp x2);

	void hole_Grenzen(FTyp& x1,FTyp& x2);

	bool steigend();
	FTyp Mitte();
	void malen(TDC& dc, TRect& viereck,FTyp& min,FTyp& max, TColor Farbe);

	inline void berechne_Aktivierung(FTyp& x);
	inline FTyp& Aktivierung() { return _Aktivierung;};

	friend ostream& operator << (ostream& os, FsSet& einFsSet);
	friend istream& operator >> (istream& is, FsSet& einFsSet);

};
inline void FsSet::berechne_Aktivierung(FTyp& x) {
	_Aktivierung=y_wert(x);
	_letzter_xwert=x;
}

inline FTyp FsSet::y_wert(FTyp& x) {

  if (_Anzahl_Intervalle==1) {
	 if (_Intervall1.enthalten(x)) {
		_verantwortliches_Intervall=1;
		return _Intervall1.y_wert(x);
	 }
	 else
		return 0;
  }
  else
	  if (_Intervall1.enthalten(x)) {
		_verantwortliches_Intervall=1;
		 return _Intervall1.y_wert(x);
	  }
	  else {
		 if (_Intervall2.enthalten(x)) {
			_verantwortliches_Intervall=2;
			return _Intervall2.y_wert(x);
		 }
		 else
			return 0;
	  }
}

inline bool FsSet::enthalten(FTyp& x) {
	if (_Anzahl_Intervalle>1) {
		return (_Intervall1.enthalten(x) || _Intervall2.enthalten(x));
	}
	else
		return (_Intervall1.enthalten(x));
}

inline bool FsSet::links_enthalten(FTyp& x) {
	return _Intervall1.enthalten(x);
}

inline bool FsSet::rechts_enthalten(FTyp& x) {
	return _Intervall2.enthalten(x);
}


#endif