#include "graphchi.h"

DEFINE_RESPONSE_TABLE1(GraphMDIChild,TMDIChild)
	EV_WM_SIZE,
	EV_WM_LBUTTONUP,
	EV_COMMAND(CM_PGCLIPBOARD, CmPGClipboard),
	EV_COMMAND(CM_PEXPORT, CmPExport),
END_RESPONSE_TABLE;

GraphMDIChild::GraphMDIChild(TMDIClient& parent,
					MesswerteListe* Liste,
					mystring Name) : 	TMDIChild(parent,""),
					_aktuell(Liste) {

	// speichert den Zeiger auf die Mewerte
	_Liste=*_aktuell;

	// Mewerte vorhanden ?
	if (_Liste.GetItemsInContainer()!=0)
		// Minimum und Maximum ermitteln
		minmax(_aktuell->GetItemsInContainer(),_ymin,_ymax);

	_Name=Name;
	mystring Titel = "Values " + Name;
	SetCaption(Titel.c_str());
}
bool GraphMDIChild::CanClose() {
	Parent->SendMessage(WM_USER,CLOSE_GRAPHCHILD ,(long)this);
	return true;
}
void GraphMDIChild::aktualisieren() {

	// gibt es neue Mewerte
	if (!(_Liste == *_aktuell)) {
		_Liste=*_aktuell;
		if (_aktuell->GetItemsInContainer()!=0)
			// Minimum und Maximum ermitteln
			minmax(_Liste.GetItemsInContainer(),_ymin,_ymax);
	}

	// neuzeichnen
	Invalidate(true);
}

void GraphMDIChild::SetupWindow() {

	TMDIChild::SetupWindow();
	SetIcon(GetApplication(),ICON_MESSWERTE);

	_Schrift= new TFont("Arial",14);

	// Gre des Fensters geeignet whlen
	TRect parentRect;
	Parent->GetWindowRect(parentRect);
	int breite = parentRect.Width() / 2;
	int hoehe =  parentRect.Height() / 4;
	MoveWindow(40,40,breite, hoehe);
}

TRect GraphMDIChild::berechne_Bildviereck(TRect& groesse) {

	// Bereich, der zur Ausgabe der Mewerte innerhalb des Fensters
	// genutzt wird, berechnen

	TRect bild=groesse;

	bild.left+=RAND_LINKS;
	bild.right-=RAND_RECHTS;
	bild.top+=RAND_OBEN;
	bild.bottom-=RAND_UNTEN;

	return bild;
}

void GraphMDIChild::EvSize(UINT sizeType, TSize& Size) {

	// falls die Gre des Fensters verndert wird, neuzeichnen

	TMDIChild::EvSize(sizeType,Size);
	Invalidate(false);
}


void GraphMDIChild::minmax(int breite,FTyp& Min,FTyp& Max) {

	// bestimmt Minimum und Maximum ber die Mewerte,
	// fngt den Sonderfall ab, bei dem alle Mewerte identisch sind

	MesswerteIter Iter(_Liste);
	Min=Max=Iter.Current();

	int zaehler(breite);

	while (Iter && (zaehler>0)) {

		if (Iter.Current() > Max)
			Max=Iter.Current();
		if (Iter.Current() < Min)
			Min=Iter.Current();

		--zaehler;
		Iter++;
	}

	if (Min==Max) {
			if (Min==0) {

				Max=1;

				Min=-1;

			}

			else {

				FTyp dy;

				if (Min<0)

					dy=-Min;

				else

					dy=Min;


				Min-=dy;

				Max+=dy;

			}

		}
}
void GraphMDIChild::Paint(TDC&, bool, TRect& ) {

	TClientDC mydc(*this);
	TRect groesse=GetClientRect();

	mydc.SelectStockObject(WHITE_PEN);
	mydc.SelectStockObject(WHITE_BRUSH);
	mydc.Rectangle(groesse);
	mydc.SelectStockObject(BLACK_PEN);

	mydc.SelectObject(TBrush(TColor::LtRed));
	mydc.SelectObject(*_Schrift);
	mydc.SetTextColor(TColor::Black);

	// sinnvolle Ausgabe mglich ?

	if (_Liste.GetItemsInContainer()<2) {
		mydc.SetTextAlign(TA_CENTER | TA_BASELINE);
		mydc.TextOut(groesse.left+groesse.Width()/2,
						groesse.bottom-groesse.Height()/2,
						"No values, yet.",23);
		return;
	}

	Parent->SetCursor(0,IDC_WAIT);

	TPoint p;

	MesswerteIter Iter(_Liste);

	// Koordinatenkreuz
	TRect bild=berechne_Bildviereck(groesse);
	int breite  = bild.right - bild.left;

	// falls Fenster gengend gro, einzelne Mewerte durch Rechtecke
	// markieren
	bool Rechtecke=(breite > _Liste.GetItemsInContainer());
	// breite=min(breite,_Liste.GetItemsInContainer());
	breite=_Liste.GetItemsInContainer();

	// Achsen mit Beschriftungen zeichnen
	Lineal XAchse;
	XAchse.Grenzen_x(0,breite);
	XAchse.Grenzen_y(_ymin,_ymax);
	XAchse.zeichne(mydc,bild,true,true,true,true);
	XAchse.zeichne(mydc,bild,false);


	// alle Mewerte ausgeben
	if (Iter) {
		p=XAchse.projiziere(bild,0,Iter.Current());
		mydc.MoveTo(p);
		Iter++;

		int zaehler=1;

		// sollen Mewerte markiert werden ?
		if (Rechtecke) {
			// mit Rechtecken ausgeben
			while (Iter) {
				p=XAchse.projiziere(bild,zaehler,Iter.Current());
				mydc.LineTo(p);
				mydc.Rectangle(p.x-2,p.y-2,p.x+2,p.y+2);
				zaehler++;
				Iter++;
			}
		}
		else {
			// ohne Rechtecke ausgeben
			while (Iter) {
				p=XAchse.projiziere(bild,zaehler,Iter.Current());
				mydc.LineTo(p);
				zaehler++;
				Iter++;
			}
		}
	}
	Parent->SetCursor(0,IDC_ARROW);
}
GraphMDIChild::~GraphMDIChild() {
	delete _Schrift;
}
void GraphMDIChild::EvLButtonUp(UINT, TPoint& point) {

	// Men konstruieren
	TPopupMenu PopupMenu;
	TRect rect;
	GetWindowRect(rect);

	PopupMenu.AppendMenu(MF_STRING, CM_PGCLIPBOARD, "Copy into clipboard");
	PopupMenu.AppendMenu(MF_STRING, CM_PEXPORT, "Export data to file...");

	// Men darstellen
	PopupMenu.TrackPopupMenu(TPM_LEFTBUTTON,
										point.x+rect.left, point.y+rect.top,
										0,HWindow,0);
}
void GraphMDIChild::CmPGClipboard() {

	// kopiert die Darstellung in die Zwischenablage

	Invalidate(false);
	TClientDC clientDC(*this);
	TMemoryDC memDC(clientDC);
	TRect groesse=GetClientRect();

	// Bitmap konstruieren
	TBitmap* bitmap=new TBitmap(clientDC,groesse.Width(),groesse.Height(),FALSE);
	memDC.SelectObject(*bitmap);

	// aus dem Fenster kopieren in die Bitmap kopieren
	memDC.BitBlt(0,0,groesse.Width(),groesse.Height(),clientDC,0,0,SRCCOPY);

	// in die Zwischenablage kopieren
	TClipboard &clipboard = OpenClipboard();
	clipboard.EmptyClipboard();
	bitmap->ToClipboard(clipboard);
	clipboard.CloseClipboard();

	delete bitmap;
}

void GraphMDIChild::CmPExport() {

	// exportiert die Mewerte in eine Datei (ASCII)

	TOpenSaveDialog::TData fileData(OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,
			"ASCII Files(*.dat)|*.dat",0,0,"dat");
	  strcpy(fileData.FileName,mystring(_Name+".dat").c_str());
		TFileSaveDialog *dialog= new TFileSaveDialog(this,fileData);

	int result= dialog->Execute();
	delete dialog;

	if (result==IDOK) {

		Parent->SetCursor(0,IDC_WAIT);

		// Dateiname holen
		ofstream of(fileData.FileName);

		// alle Mewerte ausgeben
		MesswerteIter Iter(_Liste);
		int zaehler(0);

		while (Iter) {
			of << zaehler << " " << Iter.Current() << endl;
			zaehler++;
			Iter++;
		}
		of.close();
		Parent->SetCursor(0,IDC_ARROW);
	}
}

