#ifndef _PENDEL_
#define _PENDEL_
#include <math.h>

#define TO_BOG M_PI/180.0
#define TO_GRAD 180.0/M_PI


class Pendel {
public:
  Pendel();
  void simulation(double& kraft);

  double position();         // Position des Wagens
  void position(double);

  double wa_geschw();        // Geschwindigkeit des Wagens
  void wa_geschw(double);

  double winkel();           // Winkel des Pendels
  void winkel(double);

  double wi_geschw();        // Winkelgeschwindigkeit
  void wi_geschw(double);

private:

  double _winkel(double&, double&, double&, double&);
  double _position(double&, double&, double&, double&, double&);
  double _werte[4];
  double sgn(double&);

  inline double bog_to_grad(double&);
  inline double grad_to_bog(double&);

};


inline double Pendel::sgn(double& x) { return (x >= 0) ? 1 : -1; };

inline double Pendel::grad_to_bog(double& grad) { return grad * TO_BOG; };
inline double Pendel::bog_to_grad(double& bogen) { return bogen * TO_GRAD; };


#endif