#include "kenndial.h"

DEFINE_RESPONSE_TABLE1(TKennfeldDialog, TCenterDialog)
	EV_CHILD_NOTIFY(IDOK, BN_CLICKED, HandleOK),
	EV_CHILD_NOTIFY(IDCANCEL, BN_CLICKED, HandleOK),
END_RESPONSE_TABLE;

TKennfeldDialog::TKennfeldDialog(TWindow* parent, int Aufloesung,
											bool Gitter, Farbschema Schema) :
	TCenterDialog (parent,DIALOG_KENNFELD),

	// Dialogelemente initialisieren
	_Aufloesung(Aufloesung), _Gitter(Gitter), _Schema(Schema),
	_GroesseBereich(2,85),
	_Eingabe(this,IDC_GROESSE,16),
	_mitGitter(this,IDC_MITGITTER),
	_Auswahl(this,IDC_SCHEMA) {

		// Namen der Farbschemata initialisieren
		_SchemaNamen[blau]="blue" ;
		_SchemaNamen[rot]="red" ;
		_SchemaNamen[grau]="gray" ;
		_SchemaNamen[orange]="orange" ;
		_SchemaNamen[gruen]="green" ;
		_SchemaNamen[sgruen]="black-red" ;
		_SchemaNamen[gelbblau]="yellow-blue" ;

}

void TKennfeldDialog::SetupWindow() {
	char buf[16];

	// Kennfeldauflsung initialisieren
	wsprintf(buf,"%d",_Aufloesung);

	TCenterDialog::SetupWindow();
	_Eingabe.SetText((char *)buf);

	// Checkbox initialisieren
	if (_Gitter)
		_mitGitter.Check();

	// Auswahlmglichkeiten fr Farbschemata initialisieren
	for (int i=0; i<Schemata; i++) {
		_Auswahl.AddString(_SchemaNamen[i]);
	}

	// aktuell verwendetes Farbschema in die Auswahl schreiben
	_Auswahl.SetText(_SchemaNamen[_Schema]);

}

void TKennfeldDialog::HandleOK() {
	char Aufloesung[16];
	char Name[16];

	// Auflsung ermitteln, Bereichsberprfung
	_Eingabe.GetText((char *)&Aufloesung,16);
	if (!_GroesseBereich.IsValid((char *)&Aufloesung) )
		MessageBox("Error: 1 < Resolution < 86 !","Resolution",MB_OK);
	else {
		_Aufloesung=atoi((char *)&Aufloesung);

		// aktuelles Farbschema ermitteln
		_Auswahl.GetText((char *)&Name,16);

		Farbschema i(blau);
		bool suche(true);

		while (i<= gruen && suche) {
			if (strncmp( (char *)&Name, _SchemaNamen[i],16)==0)
				suche=false;
			else
				i++;
		}
		_Schema=i;

		// Gitter zeichnen ?
		_Gitter=_mitGitter.GetCheck();

		TCenterDialog::CloseWindow();
	}
}