#include "lineal.h"
void Lineal::berechne_Grenzen(FTyp& von,FTyp& bis,FTyp& mag) {

	// berechnet die Beschriftungsgrenzen

	FTyp dx=bis-von;
	FTyp step = log10(dx)/log10(10);

	step = floor(step)-mag;
	step = pow10(step);

	von /= step;
	if (von < 0.0)
		von = ceil(von);
	else
		von = floor(von);


	bis /= step;

	if (bis < 0.0)
		bis = ceil(bis);
	else
		bis = floor(bis);

}
////////////////////////////////////////////////////////////////////////////////
FTyp Lineal::berechne_Schrittweite(FTyp& von,FTyp& bis) {

	// wird fr die Berechnung der Schrittweite verwendetet

	FTyp dx=bis-von;
	FTyp step = log(dx)/log(10);
	step = floor(step);
	return step;

}
////////////////////////////////////////////////////////////////////////////////
int Lineal::berechne_modulo(FTyp von,FTyp bis) {

	// berechnet grobe Stricheinteilung

	von = bis- von;

	if (von < 5)
		return 1;
	if (von < 10)
		return 2;
	if (von < 20)
		return 5;
	if (von < 50)
		return 10;
	return 20;
}
int Lineal::berechne_modulo2(int von) {

	// berechnet feine Stricheinteilung

	if (von==20)
		return 5;

	return 1;

}
//==============================================================================
void Lineal::zeichne(TDC& mydc,TRect& bild,bool horiz, bool mit_Ziffern,
							bool x0,bool y0) {


	// zeichnet die beschrifteten Achsen  in ein Fenster,
	// wahlweise horizontal oder vertikal

	char s[16];
	FTyp von,bis,von2,bis2,step,count,breite,scale;
	int mo,mo2;

	TPoint p1,p2;

	// soll horizontal gezeichnet werden ?

	if (horiz) {
		von=von2=_xmin;
		bis=bis2=_xmax;

		// Punkte projizieren

		p1=projiziere(bild,_xmin,_ymin);
		mydc.MoveTo(p1);
		p2=projiziere(bild,_xmax,_ymin);
		mydc.LineTo(p2);
		mydc.SetTextAlign(TA_CENTER | TA_TOP);

		// Achse zeichnen

		if (_ymin < 0 && _ymax > 0 && y0) {
			p1=projiziere(bild,_xmin,0);
			p2=projiziere(bild,_xmax,0);
			mydc.SelectObject(TPen(TColor::Black,1,PS_DOT));
			mydc.MoveTo(p1);
			mydc.LineTo(p2);
			mydc.SelectStockObject(BLACK_PEN);
		}

	}
	else {
		von=von2=_ymin;
		bis=bis2=_ymax;

		// Punkte projizieren

		p1=projiziere(bild,_xmin,_ymax);
		mydc.MoveTo(p1);
		p2=projiziere(bild,_xmin,_ymin);
		mydc.LineTo(p2);
		mydc.SetTextAlign(TA_RIGHT | TA_BASELINE);

		// Achse zeichnen

		if (_xmin < 0 && _xmax > 0 && x0) {
			p1=projiziere(bild,0,_ymin);
			p2=projiziere(bild,0,_ymax);
			mydc.SelectObject(TPen(TColor::Black,1,PS_DOT));
			mydc.MoveTo(p1);
			mydc.LineTo(p2);
			mydc.SelectStockObject(BLACK_PEN);
		}
	}

	// Markierungen auf der Achse berechnen
	step=(berechne_Schrittweite(von,bis));

	berechne_Grenzen(von,bis,0);
	berechne_Grenzen(von2,bis2,1);

	scale=pow10(step);

	if ((von-bis) < 3) {
		von=von2;
		bis=bis2;
		scale/=10;
	}
	mo = berechne_modulo(von,bis);
	mo2 = berechne_modulo2(mo);

	// vertikal ausgeben ?
	if (horiz)
		for (count=von; count <= bis; count++) {
			// groer Strich ?
			if (((int)count%mo)!=0) {
				// nein, kleiner Strich ?
				if (((int)count%mo2)==0) {
					// ja
					p1=p2=(projiziere(bild,count*scale,_ymin));
					p1.y-=3;
					mydc.MoveTo(p1);
					p2.y+=3;
					mydc.LineTo(p2);

				}
			}
			else {
				// zustzlich beschriften
				p1=p2=(projiziere(bild,count*scale,_ymin));
				p1.y+=6;
				mydc.MoveTo(p1);
				p2.y-=6;
				mydc.LineTo(p2);

				if (mit_Ziffern) {
					p2.y += 15;
					sprintf(s,"%.1f",count*scale);
					mydc.TextOut(p2,s,strlen(s));
				}

			}

		}
	else
		// horizontal ausgeben ?
		for (count=von; count <= bis; count++) {
			// groer Strich ?
			if (((int)count%mo)!=0) {
				// nein, kleiner Strich ?
				if (((int)count%mo2)==0) {
					// ja
					p1=p2=(projiziere(bild,_xmin,count*scale));
					p1.x-=2;
					mydc.MoveTo(p1);
					p2.x+=2;
					mydc.LineTo(p2);

				}
			}
			else {
				// groer Strich mit Beschriftung
				p1=p2=(projiziere(bild,_xmin,count*scale));
				p1.x+=4;
				mydc.MoveTo(p1);
				p2.x-=4;
				mydc.LineTo(p2);

				if (mit_Ziffern) {
					p2.x -= 5;
					sprintf(s,"%.2g",count*scale);
					mydc.TextOut(p2,s,strlen(s));
				}

			}

		}
}

TPoint Lineal::projiziere(TRect& bild, FTyp& x ,FTyp& y) {
	TPoint punkt;
	punkt.x=bild.left+(x-_xmin)/(_xmax-_xmin)*(bild.right-bild.left);
	punkt.y=bild.bottom-(y-_ymin)/(_ymax-_ymin)*(bild.bottom-bild.top);
	return punkt;
}


