#include "mainwin.h"

TMyMainWindow::TMyMainWindow(const char* title,
										TResId menu,
										TMDIClient& client, bool abool, TModule* module) :
	TDecoratedMDIFrame(title, menu, client, abool, module) {

	// Statusbar fr die Anzeige der Hilfstexte zu den Meneintrgen erzeugen
	_MyStatusBar= new TStatusBar(this, TGadget::Recessed);

	// Controlbar fr die Piktogrammleiste erzeugen
	_MyControlBar= new TControlBar(this);
	_MyControlBar->SetBkgndColor(TColor::LtGray);
	_MyControlBar->Insert(*new TButtonGadget(CM_NEU,CM_NEU,TButtonGadget::Command));
	_MyControlBar->Insert(*new TSeparatorGadget(3));
	_MyControlBar->Insert(*new TButtonGadget(CM_FILEOPEN,CM_FILEOPEN,TButtonGadget::Command));
	_MyControlBar->Insert(*new TButtonGadget(CM_FILESAVEAS,CM_FILESAVEAS,TButtonGadget::Command));
	_MyControlBar->Insert(*new TSeparatorGadget(3));
	_MyControlBar->Insert(*new TButtonGadget(CM_START,CM_START,TButtonGadget::Command));
	_MyControlBar->Insert(*new TSeparatorGadget(12));

	_MyControlBar->Insert(*new TButtonGadget(CM_TILECHILDRENVERT,CM_TILECHILDRENVERT,TButtonGadget::Command));
	_MyControlBar->Insert(*new TButtonGadget(CM_TILECHILDRENHORIZ,CM_TILECHILDRENHORIZ,TButtonGadget::Command));

	_MyControlBar->Insert(*new TSeparatorGadget(12));
	_MyControlBar->Insert(*new TButtonGadget(CM_FILEEXIT,CM_FILEEXIT,TButtonGadget::Command));

	// beide in das Rahmenfenster einfgen
	Insert(*_MyStatusBar, TDecoratedFrame::Bottom);
	Insert(*_MyControlBar, TDecoratedFrame::Top);

	Attr.AccelTable = "Accels";

}

TMyMainWindow::~TMyMainWindow() {

	// Status- und Controlbar freigeben
	delete(_MyStatusBar);
	delete(_MyControlBar);
}



