#include "mymdicli.h"

DEFINE_RESPONSE_TABLE1(TMyMDIClient, TMDIClient)

	EV_COMMAND(CM_ABOUT, CmAbout),
	EV_COMMAND(CM_EDITCONTROLLER, CmEditController),
	EV_COMMAND(CM_FILEOPEN, CmFileOpen),
	EV_COMMAND(CM_FILESAVEAS, CmFileSaveAs),
	EV_COMMAND(CM_NEU,CmNeu),

	EV_COMMAND(CM_TILECHILDRENHORIZ, CmTileChildrenHoriz),
	EV_COMMAND(CM_TILECHILDRENVERT, CmTileChildrenVert),
	EV_COMMAND(CM_CASCADECHILDREN, CmCascadeChildren),

	EV_COMMAND(CM_START, CmStarteController),
	EV_MESSAGE(WM_USER, Mailbox),
	EV_WM_ERASEBKGND,
	EV_WM_SETFOCUS,

END_RESPONSE_TABLE;
//##############################################################################
// MDI-Client
//##############################################################################
TMyMDIClient::TMyMDIClient(HINSTANCE hInstance,
									MetaController* Meta):
	TMDIClient(),
	_Meta(Meta),
	_hInstance(hInstance),
	IOManager(Meta,hInstance) {

	_Abbruch=true;

	HINSTANCE hInstance2 = *GetApplication();
	#ifndef ROOT_TU_LOGO
	// Hintergrund normal
	_root = new TBitmap (hInstance2, BITMAP_STUCCO);
	#else

	// Hintergrund im Hauptfenster gekachelt

	TClientDC mydc(*this);

	TBitmap* bitmap = new TBitmap (hInstance2, BITMAP_ROOT2);
	_root = new TBitmap(mydc, 250,314,true);
	TMemoryDC memDC1(mydc);
	memDC1.SelectObject(*bitmap);

	TMemoryDC memDC2(mydc);
	memDC2.SelectObject(*_root);

	memDC2.BitBlt(-bitmap->Width()/2,0, bitmap->Width(), bitmap->Height(),
						memDC1,0,0,SRCCOPY);
	memDC2.BitBlt(bitmap->Width()/2,0, bitmap->Width(), bitmap->Height(),
						memDC1,0,0,SRCCOPY);
	memDC2.BitBlt(bitmap->Width()+bitmap->Width()/2,0, bitmap->Width(), bitmap->Height(),
						memDC1,0,0,SRCCOPY);

	memDC2.BitBlt(0,bitmap->Height(), bitmap->Width(), bitmap->Height(),
						memDC1,0,0,SRCCOPY);
	memDC2.BitBlt(bitmap->Width(),bitmap->Height(), bitmap->Width(), bitmap->Height(),
						memDC1,0,0,SRCCOPY);

	delete bitmap;
	#endif

	// Farbschemata definieren
	_palette=0;
	_Palette_fuer_alle=0;

	FaktorRot  [blau] =  -100;
	FaktorGruen[blau] = 150;
	FaktorBlau [blau] =  155;
	BiasRot  [blau] = 125;
	BiasGruen[blau] = 55;
	BiasBlau [blau] = 100;

	FaktorRot  [gelbblau] = 255;
	FaktorGruen[gelbblau] = 240;
	FaktorBlau [gelbblau] = -100;
	BiasRot  [gelbblau] = 0;
	BiasGruen[gelbblau] = 0;
	BiasBlau [gelbblau] = 255;


	FaktorRot  [sgruen] = -90;
	FaktorGruen[sgruen] = 140;
	FaktorBlau [sgruen] = 180;
	BiasRot  [sgruen] = 140;
	BiasGruen[sgruen] = 0;
	BiasBlau [sgruen] = 0;


	FaktorRot  [rot] = 255;
	FaktorGruen[rot] = 40;
	FaktorBlau [rot] = 80;
	BiasRot  [rot] = 0;
	BiasGruen[rot] = 0;
	BiasBlau [rot] = 0;

	FaktorRot  [grau] = 255;
	FaktorGruen[grau] = 255;
	FaktorBlau [grau] = 255;
	BiasRot  [grau] = 0;
	BiasGruen[grau] = 0;
	BiasBlau [grau] = 0;

	FaktorRot  [orange] = 80;
	FaktorGruen[orange] = 255;
	FaktorBlau [orange] = 0;
	BiasRot  [orange] = 175;
	BiasGruen[orange] = 0;
	BiasBlau [orange] = 0;


	FaktorRot  [gruen] =  100;
	FaktorGruen[gruen] = 255;
	FaktorBlau [gruen] =  155;
	BiasRot  [gruen] = 0;
	BiasGruen[gruen] = 0;
	BiasBlau [gruen] = 0;

	_EditController=0;

}
TMyMDIClient::~TMyMDIClient() {

	// Bitmap fr den Hintergrund freigeben
	delete _root;

	// falls Paletten definiert, freigeben
	if (_Palette_fuer_alle) {
		delete _Palette_fuer_alle;
	}
	if (_palette)
		delete _palette;
}
void TMyMDIClient::EvSetFocus(HWND hwnd) {

	// falls NEFCON-WIN den Eingabefocus erhlt, mu die Anwendung der
	// verwendeten Palette neu angemahnt werden

	TMDIClient::EvSetFocus(hwnd);
	if (_Palette_fuer_alle) {
		TClientDC clientDC(*this);
		#if !defined(__WIN32__)
			_Palette_fuer_alle->UnrealizeObject();
		#endif
	 clientDC.SelectObject(*_Palette_fuer_alle, FALSE);
	 clientDC.RealizePalette();
  }
}
void TMyMDIClient::SetupWindow() {
	TMDIClient::SetupWindow();

	// welchen Farbmodus haben wir denn ?
	TScreenDC screenDC;
	int AnzahlFarben=screenDC.GetDeviceCaps(NUMCOLORS);

	if ((AnzahlFarben > 16) && (AnzahlFarben<=256)) {

		// beim 16- und 256-Farbmodus ist die Verwendung einer Palette sinnvoll,
		// da Darstellungen sonst gerastert erfolgen

		// Palette anfordern
		_palette = (LOGPALETTE*)new char[sizeof(LOGPALETTE) + sizeof(PALETTEENTRY) * ANZAHL_PALETTENFARBEN];
		_palette->palVersion = 0x300;
		_palette->palNumEntries = ANZAHL_PALETTENFARBEN;

		// aus den Farbschemata eine Palette basteln
		int i=0;
		for (Farbschema j=blau ; j<=gruen; j++) {

			FTyp 	rotf(FaktorRot[j]),
					gruenf(FaktorGruen[j]),
					blauf(FaktorBlau[j]);

			FTyp 	rotb(BiasRot[j]),
					gruenb(BiasGruen[j]),
					blaub(BiasBlau[j]);

			for (FTyp k=0; k<FARBEN_PRO_SCHEMA; ++k,++i) {
				_palette->palPalEntry[i].peRed = rotb+k/FARBEN_PRO_SCHEMA*rotf;
				_palette->palPalEntry[i].peGreen = gruenb+k/FARBEN_PRO_SCHEMA*gruenf;
				_palette->palPalEntry[i].peBlue = blaub+k/FARBEN_PRO_SCHEMA*blauf;
				_palette->palPalEntry[i].peFlags = PC_NOCOLLAPSE;
			}
		}

		// Palette verwenden
		_Palette_fuer_alle= new TPalette(_palette);
		TClientDC mydc(*this);
		mydc.SelectObject(*_Palette_fuer_alle);
		mydc.RealizePalette();

	}

	// falls gewnscht, Begrungsfenster anzeigen
	#ifdef LOGO
		TAboutDialog(this).Execute();
	#endif
	CmEditController();
}
bool TMyMDIClient::EvEraseBkgnd(HDC hDC) {

	// der Hintergrund im Fenster mu (teilweise) neu gezeichnet werden

	TDC dc(hDC);
	TMemoryDC memDC(dc);
	memDC.SelectObject(*_root);

	// Gre des Fensters ermitteln
	TRect groesse = GetClientRect();
	int xcount=groesse.Width() / (_root->Width()-2);
	int ycount=groesse.Height() / (_root->Height()-2);

	// Hintergrundbitmap solange neben- und untereinander in das Fenster kopieren
	// bis alles abgedeckt ist
	for (int y=ycount; y>=0; --y)
		for (int x=xcount; x>=0; --x)
			dc.BitBlt(x*(_root->Width()-2),y*(_root->Height()-2),
							_root->Width()-1,_root->Height()-1,memDC,
							1,1,
							SRCCOPY);

	return true;
}

void TMyMDIClient::alleGraphenupdaten() {

	// alle Protokollfenster sollen aktualisiert werden

	FensterlisteIter Iter(_alleGraphen);
	while (Iter) {
		Iter.Current()->aktualisieren();
		Iter++;
	}
}
void TMyMDIClient::alleSetEditsupdaten() {

	// alle Fuzzy-Mengen - Editoren sollen aktualisiert werden

	SetEditlisteIter Iter(_alleSetEdits);
	while (Iter) {
		Iter.Current()->Invalidate(false);
		Iter++;
	}
}
void TMyMDIClient::alleRegelEditsupdaten() {

	// alle Regelbasen-Editoren sollen aktualisiert werden

	RegelEditlisteIter Iter(_alleRegelEdits);
	while (Iter) {
		Iter.Current()->aktualisieren();
		Iter++;
	}
}
void TMyMDIClient::schliesseController() {

	// der Controllereditor wurde geschlossen
	_EditController=0;
}

void TMyMDIClient::schliesseGraph(GraphMDIChild* Graph) {

	// ein Protokollfenster wurde geschlossen
	// der MDI-Klient entfernt es aus seiner Liste
	_alleGraphen.Detach(Graph);

}
void TMyMDIClient::schliesseSetedit(TSetEdit* Editor) {

	// ein Fuzzy-Mengen - Editor wurde geschlossen
	// der MDI-Klient entfernt es aus seiner Liste
	Editor->Var_holen()->setze_EditFenster(0);
	_alleSetEdits.Detach(Editor);
}

void TMyMDIClient::schliesseRegeledit(TRegelEdit* Editor) {

	// ein Regelbasen-Editor wurde geschlossen
	// der MDI-Klient entfernt es aus seiner Liste

	Editor->Regelbasis_holen().setze_EditFenster(0);
	_alleRegelEdits.Detach(Editor);

}
// Controllereditor==============================================================
void TMyMDIClient::CmEditController() {

	// der Controllereditor wird angezeigt, falls er schon vorhanden
	// sonst erstellt und angezeigt

	if (_Abbruch) {

		if (_EditController) {
			if (_EditController->IsIconic())
				_EditController->Show(SW_RESTORE);
			else
				_EditController->SetFocus();
		}
		else {
			TControlChild* child=new TControlChild(*this,_Meta);
			child->Create();
			_EditController=child;
		}
	}
}
// Aufzeichnungen der Mewerte=================================================
void TMyMDIClient::neues_Messwerte_Fenster(MesswerteListe* Liste,mystring& titel) {

	// ein neues Protokollfenster wird erstellt und in die Liste der
	// zu aktualisierenden Fenster aufgenommen

	GraphMDIChild* child=
		new GraphMDIChild(*this,Liste,titel);
	child->Create();
	_alleGraphen.append(child);
}
void TMyMDIClient::neues_3DMess_Fenster(FController* Controller,bool Fehler) {

	// ein neues 3D-Protokollfenster wird erstellt

	// Da diese Fensterart nicht automatisch nach einer Regeluing aktualisiert
	// wird, mu der MDI-Klient auch nicht im Detail wissen, welche gerade
	// geffnet sind.

	dreidmess* child=
		new dreidmess(*this,Controller,Fehler);
	child->Create();
}

// Regelbasen===================================================================
void TMyMDIClient::neues_Regelbasis_Fenster(Regelbasis& Basis,mystring& titel) {

	// der Regelbasen-Editor fr die angegebene Basis soll geffnet werden

	// falls er bereits existiert, erhlt der den Eingabefocus
	// verhindert Dateninkonsistenzen z.B. durch zwei parallel geffnete
	// Regelbasen-Editoren fr dieselbe Regelbasis

	TWindow* EditFenster=Basis.EditFenster_holen();

	if (EditFenster) {
		if (EditFenster->IsIconic())
			EditFenster->Show(SW_RESTORE);
		else
			EditFenster->SetFocus();
	}
	else {
		TRegelEdit* child=
			new TRegelEdit(*this,0,Basis,titel);
		child->Create();
		Basis.setze_EditFenster(child);
		_alleRegelEdits.append(child);
	}
}


// Bearbeiten===================================================================
void TMyMDIClient::neues_SetEdit_Fenster(Variable* Var,
														bool istAusgabeVar,
														bool istFehlerVar) {

	// der Fuzzy-Mengen Editor fr die angegebene Variable soll geffnet werden

	// falls er bereits existiert, erhlt der den Eingabefocus (s.o.)

	TWindow* EditFenster=Var->EditFenster_holen();
	if (EditFenster) {
		if (EditFenster->IsIconic())
			EditFenster->Show(SW_RESTORE);
		else
			EditFenster->SetFocus();
	}
	else {

		TSetEdit* child=
			new TSetEdit(*this,Var,istAusgabeVar,istFehlerVar);
		child->Create();
		Var->setze_EditFenster(child);
		_alleSetEdits.append(child);
	}

}


// ANZEIGEN=======================================================================
void TMyMDIClient::neues_Kennfeld_Fenster(FController* Controller,bool Fehler) {

	// ein neues Kennfeldfenster wird erstellt

	TSurfaceMDIChild* child=
		new TSurfaceMDIChild(*this,_Palette_fuer_alle,Controller,Fehler);
	child->Create();
}

void TMyMDIClient::neues_Regelaktivitaeten_Fenster(FController* Controller, bool Fehler) {

	// ein neues Regelaktivittenfenster wird erstellt
	TActivityChild* child=
		new TActivityChild(*this,_Palette_fuer_alle,Controller, Fehler);
	child->Create();

}

void TMyMDIClient::neues_MaxRegelaktivitaeten_Fenster(FController* Controller, bool Fehler) {

	// ein neues Regelabdeckungsfenster wird erstellt

	TMaxActivityChild* child=
		new TMaxActivityChild(*this,_Palette_fuer_alle,Controller, Fehler);
	child->Create();

}

// Hilfe========================================================================
void TMyMDIClient::CmAbout() {

	// das Begrungsfenster wird angezeigt

	if (_Abbruch) {
		TAboutDialog* Info=new TAboutDialog(this);
		Info->Execute();
		delete Info;
	}
}
// Fenster======================================================================
void TMyMDIClient::CmTileChildrenHoriz() {

	// die Fenster im Arbeitsbereich werden horizontal angeordnet

	if (_Abbruch)
		TileChildren(MDITILE_VERTICAL);
}
void TMyMDIClient::CmTileChildrenVert() {

	// die Fenster im Arbeitsbereich werden vertikal angeordnet

	if (_Abbruch)
		TileChildren(MDITILE_HORIZONTAL);
}
void TMyMDIClient::CmCascadeChildren() {

	// die Fenster im Arbeitsbereich werden kaskadiert
	if (_Abbruch)
		CascadeChildren();
}
// Controller===================================================================
bool TMyMDIClient::Verbindung_aufbauen() {

	// baut eine Verbindung zum Prozeserver auf und berprft, ob er
	// mit der Architektur des NEFCON-Systems kompatibel ist

	bool DDE_Fehler=false,inkompatibel=false;

	DDE_Fehler = DDE_Fehler || !IOManager.Connect();
	DDE_Fehler = DDE_Fehler || !IOManager.DDE_init();
	DDE_Fehler = DDE_Fehler || !IOManager.Anwendung_initialisieren();

	// Problem ?
	if (DDE_Fehler)
		MessageBox("No connection with application. Not started, yet ?","Error", MB_OK | MB_ICONSTOP);
	else {

		// Identifikation anfordern
		char* Ergebnis;
		DDE_Fehler = DDE_Fehler || !IOManager.Anwendung_identifizieren();
		istrstream in(IOManager.Ergebnis());

		mystring Anwendungsname;
		in >> Anwendungsname;

		// Architektur berprfen
		int Anzahl_EingabeVariable,Anzahl_AusgabeVariable;
		in >> Anzahl_EingabeVariable >> Anzahl_AusgabeVariable;
		inkompatibel = (Anzahl_EingabeVariable != _Meta->Anzahl_EingabeVariable()) ||
							(Anzahl_AusgabeVariable != _Meta->Anzahl_Controller());

		// Problem ?
		if (inkompatibel) {
			mystring Mitteilung;
			Mitteilung = "Application " + Anwendungsname + " is incompatible with controller.";
			MessageBox(Mitteilung.c_str(),"Error", MB_OK | MB_ICONSTOP);
		}
	}
	return (DDE_Fehler || inkompatibel);
}


void TMyMDIClient::CmStarteController() {

	// ruft den Controllerdialog auf und fhrt die verschiedenen Aktionen aus:
	// regeln, Fuzzy-Mengen adaptieren oder Kontrollregeln lernen

	if (_Abbruch) {

		bool DDE_Fehler=false; 	// speichert den Rckgabewert der Kommunikations-
										// routinen

		// Controllerdialog aufrufen
		TControlDialog* ParameterDlg = new TControlDialog(this,_Meta);
		ParameterDlg->Execute();

		// wurde der Dialog mit Cancel beendet ?
		if (ParameterDlg->hol_Abbruch()) {
			delete ParameterDlg;
			return;
		}
		else {
			FTyp Fehler;
			int _Epochen;

			// Parameter aus der Dialogbox holen und im Metacontroller speichern
			_Meta->setze_Parameter(ParameterDlg->Parameter_holen());

			// Parameterdialog entfernen
			ParameterDlg->CloseWindow();
			delete ParameterDlg;


			// Metacontroller zur Auswertung vorbereiten

			// Problem (z.B. eine Fuzzy-Menge undefiniert) ?
			if (!_Meta->Auswertung_vorbereiten()) {
				MessageBox(_Meta->hol_Fehlermeldung().c_str(),"Error",  MB_OK | MB_ICONSTOP);
				return;
			}

			// alte Mewerte verwerfen
			_Meta->Messwerte_loeschen();

			// Parameter holen
			ControllerParameter& Parameter=_Meta->Parameter_holen();

			// wieviele Zyklen ?
			_Epochen=Parameter._Epochen;

			// Statistik initialisieren
			long int Epoche=0;
			int Erfolge(0),Misserfolge(0);

			// Abbruchdialog erstellen
			TAbortDialog* Abbruch = new TAbortDialog(this);
			_Abbruch=false;

			if (Parameter._Lernmodus==Fuzzy_adaptieren) {

				// Fuzzy-Mengen adaptieren -----------------------------------------
				_Meta->Lernen_vorbereiten();
				bool trace=Parameter._trace;

				DDE_Fehler=Verbindung_aufbauen();

				if (!DDE_Fehler)

					Abbruch->Create();
					Abbruch->Show(SW_SHOW); {

					for (;(Epoche < _Epochen) && !_Abbruch && !DDE_Fehler; ++Epoche) {

						// Eingabewerte besorgen
						DDE_Fehler = DDE_Fehler || !IOManager.Eingabewerte_holen();
						if (!DDE_Fehler) {

							_Meta->alle_Controller_adaptieren();
							_Meta->Messwerte_protokollieren();

							// Anwendungsstatus auswerten
							switch (_Meta->_Anwendungsstatus) {
								case 0:
									// Regelversagen
									++Misserfolge;
									IOManager.Anwendung_initialisieren();
									_Meta->alle_Controller_delta_ruecksetzen();
									break;

								case 1:
									// Regelung aktiv
									break;

								case 2:
									// Regelerfolg
									++Erfolge;
									IOManager.Anwendung_initialisieren();
									_Meta->alle_Controller_delta_ruecksetzen();
									MessageBeep(0);
									break;

								case 3:
									// Regelung stabil, aber nicht optimal
									break;
							}

							// neue Stellwerte senden
							DDE_Fehler = DDE_Fehler || !IOManager.Stellwerte_senden();

							Abbruch->setze_Epochen(Epoche);
						}
						if (DDE_Fehler)
							MessageBox("Connection with application lost. Application terminated ?","Error",  MB_OK | MB_ICONSTOP);


						if (trace)
							alleSetEditsupdaten();

					}
				}
			}
			else {
				// nur Regelung ----------------------------------------------------
				if (Parameter._Lernmodus==simulieren) {

					DDE_Fehler=Verbindung_aufbauen();

					if (!DDE_Fehler) {

						Abbruch->Create();
						Abbruch->Show(SW_SHOW);

						bool stop=false;

						while (!stop && !_Abbruch && !DDE_Fehler) {

							// Eingabewerte besorgen
							DDE_Fehler = DDE_Fehler || !IOManager.Eingabewerte_holen();

							if (!DDE_Fehler) {

								_Meta->alle_Controller_auswerten();
								_Meta->Messwerte_protokollieren();

								// Anwendungsstatus auswerten
								stop=(_Meta->_Anwendungsstatus!=1);

								DDE_Fehler = DDE_Fehler || !IOManager.Stellwerte_senden();


								++Epoche;
								Abbruch->setze_Epochen(Epoche);
							}
						}
						if (DDE_Fehler)
							MessageBox("Connection with application lost. Application terminated ?","Error",  MB_OK | MB_ICONSTOP);
					}
				}


				else {
					// Lernen von Kontrollregeln ------------------------------------

					if (!_Meta->Regellernen_moeglich()) {
						MessageBox("Each variable must contain at least one fuzzy-set to perform rule-learning.",
							"Error", MB_OK | MB_ICONSTOP);
					}
					else {
						if (Parameter._RegelLernVerfahren==Nauck) {

							// Prmissencontainer fr Naucks Verfahren erstellen
							// da das etwas dauern kann, eine Wartebox anzeigen
							Parent->SetCursor(0,IDC_WAIT);
							_Meta->Lernen_vorbereiten();

							TCenterDialog *warten= new TCenterDialog(this,DIALOG_REGELLERNEN_VORBEREITEN);
							warten->Create();
							warten->Show(SW_SHOW);

							_Meta->Regellernen_vorbereiten(Parameter._alte_Regeln_verwerfen);

							Parent->SetCursor(0,IDC_ARROW);

							// Wartebox wieder entfernen
							warten->Destroy();
							delete warten;
						}
						else {
							// Stellmachs Regellernverfahren vorbereiten
							_Meta->Lernen_vorbereiten();
							_Meta->Regellernen_vorbereiten(Parameter._alte_Regeln_verwerfen);
						}

						_Epochen=Parameter._RegelnEpochen;

						DDE_Fehler=Verbindung_aufbauen();

						if (!DDE_Fehler) {

							Abbruch->Create();
							Abbruch->Show(SW_SHOW);

							if (Parameter._RegelLernVerfahren==Nauck) {

								// Nauck------------------------------------------------
								for (;(Epoche < (_Epochen+Parameter._RegelnEpochen2)) && !_Abbruch && !DDE_Fehler; ++Epoche) {

									// Eingabewerte besorgen
									DDE_Fehler = DDE_Fehler || !IOManager.Eingabewerte_holen();
									if (!DDE_Fehler) {

										if (Epoche < _Epochen) {
											_Meta->alle_PraemissenContainer_auswerten(true);
											_Meta->alle_Controller_Regeln_lernen_I();
										}
										else {
											_Meta->alle_Controller_Regeln_lernen_II();
											// berechnet neuen Fehler, ruft Regeln lernen II auf...

											_Meta->alle_PraemissenContainer_auswerten(false);
											// wertet ausgewhlte Regeln aus...
										}

										_Meta->Messwerte_protokollieren();

										// Anwendungsstatus auswerten
										switch (_Meta->_Anwendungsstatus) {
											case 0:
												// Regelversagen
												IOManager.Anwendung_initialisieren();
												break;

											case 1:
												// Regelung aktiv
												break;

											case 2:
												// Regelerfolg
												IOManager.Anwendung_initialisieren();
												MessageBeep(0);
												break;

											case 3:
												// Regelung stabil, aber nicht optimal
												IOManager.Anwendung_initialisieren();
												break;
										}
									}
									Abbruch->setze_Epochen(Epoche);

									// neue Stellwerte senden
									DDE_Fehler = DDE_Fehler || !IOManager.Stellwerte_senden();
									if (DDE_Fehler)
										MessageBox("Connection with application lost. Application terminated ?","Error",  MB_OK | MB_ICONSTOP);


								}
								if (!_Abbruch) {
									_Meta->alle_neuen_Regeln_uebernehmen((_Epochen+Parameter._RegelnEpochen2) * Parameter._MindestRegelAktivierung);
									MessageBeep(0);
								}
							}

							else {

								// Stellmach--------------------------------------------

								for (;(Epoche < _Epochen) && !_Abbruch && !DDE_Fehler; ++Epoche) {

								// Eingabewerte besorgen
								DDE_Fehler = DDE_Fehler || !IOManager.Eingabewerte_holen();
								if (!DDE_Fehler) {

									_Meta->alle_Controller_nur_Fehler_auswerten();

									_Meta->alle_Controller_Regeln_lernen_I();
									_Meta->Messwerte_protokollieren();

									// Anwendungsstatus auswerten
									switch (_Meta->_Anwendungsstatus) {
										case 0:
											// Regelversagen
											IOManager.Anwendung_initialisieren();
											break;

										case 1:
											// Regelung aktiv
											break;

										case 2:
											// Regelerfolg
											IOManager.Anwendung_initialisieren();
											MessageBeep(0);
											break;

										case 3:
											// Regelung stabil, aber nicht optimal
											IOManager.Anwendung_initialisieren();
											break;
										}
									}
									Abbruch->setze_Epochen(Epoche);

									if (DDE_Fehler)
										MessageBox("Connection with application lost. Application terminated ?","Error",  MB_OK | MB_ICONSTOP);
								}
							}
							alleRegelEditsupdaten();
						}
					}
				}
			}

			// Ende der Regelung, Dialogbox "Abbruch" entfernen

			Abbruch->Destroy();
			delete Abbruch;
			alleGraphenupdaten();

			if (!DDE_Fehler) {

				// Verbindung abbauen
				IOManager.Unconnect();

				// Mitteilungen ber die Simulation verfassen

				ostrstream puffer;


				if (Parameter._Lernmodus==Fuzzy_adaptieren) {

					// falls Fuzzy-Mengen adaptiert wurden, alle Fuzzy-Mengen -
					// Editoren aktualisieren
					alleSetEditsupdaten();

					// Anzahl der Erfolge und Mierfolge ausgeben
					if (Erfolge==0 && Misserfolge==0)
						puffer << "No Success, no failure." << ends;
					else
						puffer << Erfolge << " times success, " << Misserfolge << " failures." << ends;

					// Mitteilungsfenster ausgeben
					MessageBox(puffer.str(),"Learning finished");
				}
				else {

					if (Parameter._Lernmodus==simulieren) {


						// falls nur geregelt wurde, letzten Anwendungsstatus auswerten
						switch (_Meta->_Anwendungsstatus) {
							case 0:
								// Regelversagen
								puffer << "Controller failed after " << Epoche << " cycles." << ends;
								// Mitteilungsfenster ausgeben
								MessageBox(puffer.str(),"Failure");
								break;

							case 1:
								// Regelung war aktiv
								puffer << "Abort after " << Epoche << " cycles." << ends;
								// Mitteilungsfenster ausgeben
								MessageBox(puffer.str(),"Abort");
								break;

							case 2:
								// Regelerfolg
								puffer << "Controller succeded after " << Epoche
								<< " cycles."
								<< ends;
								MessageBeep(0);
								// Mitteilungsfenster ausgeben
								MessageBox(puffer.str(),"Success");
								break;

							case 3:
								// Regelung war stabil, aber nicht optimal
								puffer << "Application after " << Epoche
								<< " cycles constant, but suboptimal."
								<< ends;
								// Mitteilungsfenster ausgeben
								MessageBox(puffer.str(),"Failure");
								break;
						}
					}
					else {
						if (_Meta->Regellernen_moeglich())
							// Regellernen wurde erfolgreich beendet
							MessageBox("Rule-learning finished.","Success",MB_OK);
					}
				}
				delete puffer.str();
			}
			_Abbruch=true;
		}
	}
}

LRESULT TMyMDIClient::Mailbox(WPARAM para16, LPARAM para32) {

	// Diese Funktion wird aufgerufen, wenn der MDI-Klient vom einem
	// Kindfenster die Mitteilung erhlt, da es geschlossen wird.

	// Er registriert dann, da er dieses nicht mehr aktualisieren mu.

	switch (para16) {
		case CLOSE_GRAPHCHILD : {
			schliesseGraph( (GraphMDIChild*) para32);
			break;
		}
		case CLOSE_SETEDIT : {
			schliesseSetedit( (TSetEdit*) para32);
			break;
		}
		case CLOSE_REGELEDIT : {
			schliesseRegeledit( (TRegelEdit*) para32);
			break;
		}
		case ABORT : {
			_Abbruch=true;
			break;
		}
	}
	return 1;
}
bool TMyMDIClient::CanClose() {
	if (_Abbruch && _Palette_fuer_alle)
		_Palette_fuer_alle->UnrealizeObject();
	return _Abbruch;
}

void TMyMDIClient::CmFileSaveAs() {

	// der Metacontroller soll in eine Datei geschrieben werden


	if (_Abbruch) {
		// Dateidialog vorbereiten
		TOpenSaveDialog::TData fileData(OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,
			"NEFCON-WIN Files(*.nfw)|*.nfw",0,0,"nfw");
		TFileSaveDialog *dialog= new TFileSaveDialog(this,fileData);
		int result= dialog->Execute();
		delete dialog;

		if (result==IDOK) {

			// Dateiname ermitteln
			mystring Filename(fileData.FileName);
			mystring neuer_Titel = "NEFCON-WIN - " + Filename;
			Parent->SetCaption(neuer_Titel.c_str());

			Parent->SetCursor(0,IDC_WAIT);
			// speichern
			ofstream out(fileData.FileName);
			out << *_Meta;
			Parent->SetCursor(0,IDC_ARROW);
		}
	}
}
void TMyMDIClient::CmFileOpen() {

	// ein Metacontroller soll aus einer Datei gelesen werden

	if (_Abbruch) {
		// Dateidialog vorbereiten
		TOpenSaveDialog::TData fileData(OFN_FILEMUSTEXIST|OFN_PATHMUSTEXIST,
			"NEFCON-WIN Files(*.nfw)|*.nfw",0,0,"nfw");
		TFileOpenDialog *dialog= new TFileOpenDialog(this,fileData);
		int result= dialog->Execute();
		delete dialog;

		if (result==IDOK) {

			// Dateiname ermitteln
			mystring Filename(fileData.FileName);
			mystring neuer_Titel = "NEFCON-WIN - " + Filename;
			Parent->SetCaption(neuer_Titel.c_str());

			CloseChildren();
			schliesseController();

			Parent->SetCursor(0,IDC_WAIT);
			// lesen
			ifstream in(fileData.FileName);
			in >> *_Meta;
			Parent->SetCursor(0,IDC_ARROW);

			// Controllereditor aktualisieren
			CmEditController();
		}
	}
}

void TMyMDIClient::CmNeu() {

	// ein neues NEFCON-System soll erstellt werden

	if (_Abbruch) {

		// Dialog erstellen
		NeuDialog* Neu = new NeuDialog(this);
		Neu->Execute();
		bool Erfolg=Neu->war_ok();

		if (Erfolg) {

			// falls erfolgreich, neuen Metacontroller erstellen
			_Meta->generiere(Neu->Anzahl_EingabeVar_holen(),
									Neu->Anzahl_AusgabeVar_holen());
			delete Neu;
			CloseChildren();
			// Controllereditor aktualisieren
			CmEditController();
			Parent->SetCaption("NEFCON-WIN - new");
		}
		else {
			delete Neu;
		}
	}
}
//##############################################################################
// Controllereditor
//##############################################################################
DEFINE_RESPONSE_TABLE1(TControlChild,TMDIChild)
	EV_COMMAND(CM_PFUZZY, CmPFuzzy),
	EV_COMMAND(CM_PVAR, CmPVar),
	EV_COMMAND(CM_PMESSWERTE, CmPMesswerte),

	EV_COMMAND(CM_PSTEUERREGELBASIS, CmPSteuerRegelbasis),
	EV_COMMAND(CM_PFEHLERREGELBASIS, CmPFehlerRegelbasis),

	EV_COMMAND(CM_PKENNFELD_STEUER,CmPKennfeldSteuer),
	EV_COMMAND(CM_PKENNFELD_FEHLER,CmPKennfeldFehler),

	EV_COMMAND(CM_PAKTIVITAETEN_STEUER,CmPAktivitaetenSteuer),
	EV_COMMAND(CM_PAKTIVITAETEN_FEHLER,CmPAktivitaetenFehler),
	EV_COMMAND(CM_PMAXAKTIVITAETEN_STEUER,CmPMaxAktivitaetenSteuer),
	EV_COMMAND(CM_PMAXAKTIVITAETEN_FEHLER,CmPMaxAktivitaetenFehler),

	EV_COMMAND(CM_PMESS3D_STEUER,CmPMess3DSteuer),
	EV_COMMAND(CM_PMESS3D_FEHLER,CmPMess3DFehler),
	EV_COMMAND(CM_PCCLIPBOARD, CmPCClipboard),

	EV_WM_LBUTTONUP,
	EV_WM_PAINT,
	EV_WM_SIZE,
	EV_WM_GETMINMAXINFO,
END_RESPONSE_TABLE;

TControlChild::TControlChild(TMyMDIClient& parent,
										MetaController* Meta) :
	TMDIChild(parent,"Editor"), _Meta(Meta), _Parent(parent) {
	HINSTANCE hInstance= GetApplication()->GetInstance();

	// Bitmaps fr die Controller- und Variablensymbole erstellen
	_VarBitmap= new TBitmap(hInstance, BITMAP_PFEIL);
	_ControllerBitmap= new TBitmap(hInstance, BITMAP_BRAIN);

	// keine Variable wurde bisher ausgewhlt
	selektierte_EingabeVariable=0;
	selektierte_AusgabeVariable=0;
	selektierte_FehlerVariable=0;
	selektierter_Controller=0;

	// Gre und Position des Fensters geeiget initialisieren
	Attr.X=Attr.Y=0;
	Attr.H=300;
}

TControlChild::~TControlChild() {

	_Parent.schliesseController();

	// Bitmaps und Schrift freigeben
	delete _VarBitmap;
	delete _ControllerBitmap;
	delete _Schrift;
}

void TControlChild::Paint(TDC&, bool, TRect& ) {

	TClientDC mydc(*this);
	mydc.SelectObject(*_Schrift);
	mydc.SetTextAlign(TA_CENTER | TA_TOP);

	TMemoryDC memdc(mydc);
	memdc.SelectObject(*_VarBitmap);

	TMemoryDC memdc2(mydc);
	memdc2.SelectObject(*_ControllerBitmap);

	// Fensterinhalt lschen
	TRect groesse=GetClientRect();
	mydc.SelectStockObject(WHITE_PEN);
	mydc.SelectStockObject(WHITE_BRUSH);
	mydc.Rectangle(groesse);

	// y-Koordinaten der Symbole bestimmen
	FTyp dy = groesse.Height() / 3;
	ypos_EingabeVar=groesse.top +  2 * dy + dy / 2 - 16-4;
	ypos_Controller=ypos_EingabeVar - dy;
	ypos_Ausgabe=ypos_Controller-dy;

	TEingabeVarliste EingabeVarListe=_Meta->EingabeVarListe_holen();
	int Anzahl_EingabeVar = EingabeVarListe.GetItemsInContainer();

	// alle Eingabevariablen zeichnen
	if (Anzahl_EingabeVar>0) {
		FTyp dx = groesse.Width() / Anzahl_EingabeVar;

		TEingabeVarlisteIter  Iter(_Meta->EingabeVarListe_holen());

		for (int i=0; i<Anzahl_EingabeVar; ++i) {

			// Position merken
			xpos_EingabeVar[i]=groesse.left+ dx/2 +i*dx - 16;
			mydc.SetBkMode(TRANSPARENT);

			// Schatten zeichnen
			mydc.SelectStockObject(GRAY_BRUSH);
			mydc.SelectStockObject(NULL_PEN);
			mydc.Rectangle(xpos_EingabeVar[i]+5,ypos_EingabeVar+5,
								xpos_EingabeVar[i]+32+5,ypos_EingabeVar+32+5);

			// Symbol kopieren
			mydc.SelectStockObject(LTGRAY_BRUSH);
			mydc.BitBlt(xpos_EingabeVar[i],ypos_EingabeVar,32,32,
							memdc,0,0,SRCCOPY);

			// Name ausgeben
			mydc.TextOut(xpos_EingabeVar[i]+16,ypos_EingabeVar+34,
								Iter.Current()->Name().c_str(),strlen(Iter.Current()->Name().c_str()));
			Iter++;
		}
	}

	FTyp dx_Controller = groesse.Width() / _Meta->Anzahl_Controller();
	ControllerlisteIter Iter2(_Meta->ControllerListe_holen());
	dx_Ausgabe=dx_Controller/4;

	// alle Controller mit Ausgebe- und Fehlervariablen zeichnen
	for (int j=0; j<_Meta->Anzahl_Controller(); ++j,Iter2++) {

		// Positionen merken
		xpos_Controller[j]=groesse.left+ dx_Controller/2 +j*dx_Controller - 16;
		xpos_AusgabeVar[j]=xpos_Controller[j]-dx_Ausgabe;
		xpos_FehlerVar[j]=xpos_Controller[j]+dx_Ausgabe;

		// Schatten zeichnen
		mydc.SelectStockObject(GRAY_BRUSH);
		mydc.SelectStockObject(NULL_PEN);
		mydc.Rectangle(xpos_AusgabeVar[j]+5,ypos_Ausgabe+5,
								xpos_AusgabeVar[j]+32+5,ypos_Ausgabe+32+5);
		mydc.Rectangle(xpos_FehlerVar[j]+5,ypos_Ausgabe+5,
								xpos_FehlerVar[j]+32+5,ypos_Ausgabe+32+5);

		// Symbole kopieren
		mydc.BitBlt(xpos_Controller[j],ypos_Controller,32,32,
						memdc2,0,0,SRCCOPY);

		mydc.BitBlt(xpos_AusgabeVar[j],ypos_Ausgabe,32,32,
						memdc,0,0,SRCCOPY);
		mydc.BitBlt(xpos_FehlerVar[j],ypos_Ausgabe,32,32,
						memdc,0,0,SRCCOPY);

		mydc.SelectStockObject(LTGRAY_BRUSH);

		// Namen ausgeben
		mydc.TextOut(xpos_AusgabeVar[j]+16,ypos_Ausgabe+34,
			Iter2.Current()->AusgabeVar_holen().c_str(),
			strlen(Iter2.Current()->AusgabeVar_holen().c_str()));

		mydc.TextOut(xpos_FehlerVar[j]+16,ypos_Ausgabe+34,
			Iter2.Current()->FehlerVar_holen().c_str(),
			strlen(Iter2.Current()->FehlerVar_holen().c_str()));

		mydc.SelectObject(TPen(TColor::Gray,1));

		// Pfeile zwischen den Controllern und den Ausgabe- und Fehlervariablen
		// zeichnen

		Pfeil(mydc,
				xpos_Controller[j]+17,ypos_Controller-5,
				xpos_FehlerVar[j]+17,ypos_Ausgabe+47);

		Pfeil(mydc,
			xpos_Controller[j]+17,ypos_Controller-5,
			xpos_AusgabeVar[j]+17,ypos_Ausgabe+47
			);

		mydc.SelectObject(TPen(TColor::LtGreen,1));
		Pfeil(mydc,
				xpos_Controller[j]+16,ypos_Controller-5,
				xpos_FehlerVar[j]+16,ypos_Ausgabe+47);

		Pfeil(mydc,
			xpos_Controller[j]+16,ypos_Controller-5,
			xpos_AusgabeVar[j]+16,ypos_Ausgabe+47
			);

		// Pfeile zwischen den Eingabevariablen und dem Controller zeichnen

		ControllerlisteIter Iter(_Meta->ControllerListe_holen());

		for (int k=0; k<  Iter.Current()->EingabeVarListe_holen().GetItemsInContainer();++k) {

			mydc.SelectObject(TPen(TColor::LtGray,1));
			Pfeil(mydc,
					xpos_EingabeVar[k]+17,ypos_EingabeVar-5,
					xpos_Controller[j]+17,ypos_Controller+32);
					mydc.SelectObject(TPen(TColor::LtBlue,1));
			Pfeil(mydc,
					xpos_EingabeVar[k]+16,ypos_EingabeVar-5,
					xpos_Controller[j]+16,ypos_Controller+32);

		}
	}
}
void TControlChild::SetupWindow() {
	TMDIChild::SetupWindow();
	_Schrift= new TFont("Arial",14);
	SetIcon(GetApplication(),ICON_MOUSE);
}

void TControlChild::EvSize(UINT sizeType, TSize &size) {

	// falls Gre des Fensters verndert, neuzeichnen
	TMDIChild::EvSize(sizeType,size);
	Invalidate(false);
}

//CmP....-Funktionen------------------------------------------------------------
// Diese Funktionen werden aufgerufen, wenn der Benutzer in einem Kontextmen
// einen Eintrag ausgewhlt hat. Sie leiten das Kommando an den MDI-Klienten
// weiter.

void TControlChild::CmPKennfeldSteuer() {
	_Parent.neues_Kennfeld_Fenster(selektierter_Controller);
}
void TControlChild::CmPKennfeldFehler() {
	_Parent.neues_Kennfeld_Fenster(selektierter_Controller,true);
}
void TControlChild::CmPAktivitaetenSteuer() {
	_Parent.neues_Regelaktivitaeten_Fenster(selektierter_Controller,false);
}
void TControlChild::CmPAktivitaetenFehler() {
	_Parent.neues_Regelaktivitaeten_Fenster(selektierter_Controller,true);
}
void TControlChild::CmPMaxAktivitaetenSteuer() {
	_Parent.neues_MaxRegelaktivitaeten_Fenster(selektierter_Controller,false);
}
void TControlChild::CmPMaxAktivitaetenFehler() {
	_Parent.neues_MaxRegelaktivitaeten_Fenster(selektierter_Controller,true);
}
void TControlChild::CmPMess3DSteuer() {
	_Parent.neues_3DMess_Fenster(selektierter_Controller,false);
}
void TControlChild::CmPMess3DFehler() {
	_Parent.neues_3DMess_Fenster(selektierter_Controller,true);
}
void TControlChild::CmPMesswerte() {

	// ermittelt, welche Variable gerade selektiert ist und ffnet das
	// korrespondierende Protokollfenster

	if (selektierte_EingabeVariable)
		_Parent.neues_Messwerte_Fenster(selektierte_EingabeVariable->Messwerte_holen(),
													selektierte_EingabeVariable->Name());
	else
		if (selektierte_AusgabeVariable)
			_Parent.neues_Messwerte_Fenster(selektierte_AusgabeVariable->Messwerte_holen(),
													selektierte_AusgabeVariable->Name());
		else
			if (selektierte_FehlerVariable)
			_Parent.neues_Messwerte_Fenster(selektierte_FehlerVariable->Messwerte_holen(),
													selektierte_FehlerVariable->Name());
}

void TControlChild::CmPFuzzy() {

	// ermittelt, welche Variable gerade selektiert ist und ffnet den
	// korrespondierenden Fuzzy-Mengen - Editor

	if (selektierte_EingabeVariable)
		_Parent.neues_SetEdit_Fenster(selektierte_EingabeVariable,false,false);
	if (selektierte_AusgabeVariable)
		_Parent.neues_SetEdit_Fenster(selektierte_AusgabeVariable,true,false);
	if (selektierte_FehlerVariable)
		_Parent.neues_SetEdit_Fenster(selektierte_FehlerVariable,false,true);
}
void TControlChild::CmPSteuerRegelbasis() {
	if (selektierter_Controller) {
		_Parent.neues_Regelbasis_Fenster(selektierter_Controller->hol_SteuerRegelbasis(),
													selektierter_Controller->AusgabeVar_holen());
	}
}
void TControlChild::CmPFehlerRegelbasis() {
	if (selektierter_Controller) {
		_Parent.neues_Regelbasis_Fenster(selektierter_Controller->hol_FehlerRegelbasis(),
													selektierter_Controller->FehlerVar_holen());
	}
}

void TControlChild::CmPVar() {

	// ermittelt, welche Variable gerade selektiert ist und erstellt den
	// passenden Dialog

	VarDialog* VarDlg;

	if (selektierte_EingabeVariable)
		VarDlg=new VarDialog(Parent,_Meta,selektierte_EingabeVariable,true);

	if (selektierte_AusgabeVariable)
		VarDlg=new VarDialog(Parent,_Meta,selektierte_AusgabeVariable,false);

	if (selektierte_FehlerVariable)
		VarDlg=new VarDialog(Parent,_Meta,selektierte_FehlerVariable,false);

	// Dialog zeigen
	VarDlg->Execute();

	// hat sich der Definitionsbereich gendert ?
	if (VarDlg->neue_Grenzen)
		_Parent.alleSetEditsupdaten();

	// hat sich der Name verndert ?
	if (VarDlg->neuer_Name) {
		_Parent.alleRegelEditsupdaten();
		Invalidate(false);
	}

	// Dialog wieder freigeben
	delete VarDlg;

}
void TControlChild::EvLButtonUp(UINT, TPoint& point) {

	// diese Funktion erstellt das jweilige Kontexmen fr
	// einen Controller oder eine Variable

	if (_Parent._Abbruch) {

		TRect rect;
		GetWindowRect(rect);
		TPopupMenu PopupMenu;
		PopupMenu.AppendMenu(MF_STRING, CM_PCCLIPBOARD, "Copy into clipboard");

		// checkt die y-Koordinate darauf, ob mglicherweise ein Objekt gewhlt
		// wurde

		SelTyp Auswahl=Punkt_checken(point);
		switch (Auswahl)  {

			case kein: 	{

				// keine Auswahl, also auch kein Objekt gewhlt

				selektierte_EingabeVariable=0;
				selektierte_AusgabeVariable=0;
				selektierte_FehlerVariable=0;
				selektierter_Controller=0;

				break;
			}

			case EingabeVar: {

				// knnte eine Eingabevariable sein

				selektierte_AusgabeVariable=0;
				selektierte_FehlerVariable=0;
				selektierter_Controller=0;

				// Eingabevariable holen

				EingabeVariable* Var=EingabeVariable_holen(point);
				selektierte_EingabeVariable=Var;

				// gefunden ?
				if (Var) {

					// falls ja, Kontextmen einer Eingabevariablen erstellen
					PopupMenu.AppendMenu(MF_SEPARATOR);
					PopupMenu.AppendMenu(MF_STRING, CM_PFUZZY, "Fuzzy-sets");
					if (Var->Messwerte_holen()->GetItemsInContainer())
						PopupMenu.AppendMenu(MF_STRING, CM_PMESSWERTE, "Values");
					PopupMenu.AppendMenu(MF_SEPARATOR);
					PopupMenu.AppendMenu(MF_STRING, CM_PVAR, "Properties...");
					PopupMenu.TrackPopupMenu(TPM_LEFTBUTTON,
												point.x+rect.left, point.y+rect.top,
												0,HWindow,0);
				}
				break;
			}

			case AusgabeVar: {

				// knnte eine Ausgabevariable sein
				selektierte_EingabeVariable=0;
				selektierte_AusgabeVariable=0;
				selektierte_FehlerVariable=0;
				selektierter_Controller=0;

				// ist es eine Ausgabevariable ?
				AusgabeVariable* Var=AusgabeVariable_holen(point);
				if (Var)
					selektierte_AusgabeVariable=Var;
				else {
					// oder eine Fehlervariable (beide haben identische
					//										y-Koordinaten) ?
					Var=FehlerVariable_holen(point);
					if (Var)
						selektierte_FehlerVariable=Var;
				}

				if (Var) {
					// falls ja, Kontexmen einer Ausgabevariablen erstellen
					PopupMenu.AppendMenu(MF_SEPARATOR);
					PopupMenu.AppendMenu(MF_STRING, CM_PFUZZY, "Fuzzy-sets");

					// falls Mewerte vorhanden, Meneintrag bereitstellen
					if (Var->Messwerte_holen()->GetItemsInContainer())
						PopupMenu.AppendMenu(MF_STRING, CM_PMESSWERTE, "Values");

					PopupMenu.AppendMenu(MF_SEPARATOR);
					PopupMenu.AppendMenu(MF_STRING, CM_PVAR, "Properties...");
					PopupMenu.TrackPopupMenu(TPM_LEFTBUTTON,
												point.x+rect.left, point.y+rect.top,
												0,HWindow,0);
				}
				break;
			}
			case Controller: {
				selektierte_EingabeVariable=0;
				selektierte_AusgabeVariable=0;
				selektierte_FehlerVariable=0;

				// knnte ein Controller sein
				FController* Controller=Controller_holen(point);
				selektierter_Controller=Controller;

				// gefunden ?
				if (Controller) {
					mystring temp;
					PopupMenu.AppendMenu(MF_SEPARATOR);
					temp = "Rule-base " + Controller->AusgabeVar_holen();
					PopupMenu.AppendMenu(MF_STRING, CM_PSTEUERREGELBASIS, temp.c_str());
					temp = "Rule-base " + Controller->FehlerVar_holen();
					PopupMenu.AppendMenu(MF_STRING, CM_PFEHLERREGELBASIS, temp.c_str());

					// falls genau zwei Eingabevariable, dann sind 3D-Darstellungen
					// mglich

					if (_Meta->Anzahl_EingabeVariable()==2) {
						PopupMenu.AppendMenu(MF_SEPARATOR);

						temp = "Surface " + Controller->AusgabeVar_holen();
						PopupMenu.AppendMenu(MF_STRING, CM_PKENNFELD_STEUER, temp.c_str());
						temp = "Active rules " + Controller->AusgabeVar_holen();
						PopupMenu.AppendMenu(MF_STRING, CM_PAKTIVITAETEN_STEUER, temp.c_str());
						temp = "Max rule activity " + Controller->AusgabeVar_holen();
						PopupMenu.AppendMenu(MF_STRING, CM_PMAXAKTIVITAETEN_STEUER, temp.c_str());

						PopupMenu.AppendMenu(MF_SEPARATOR);
						temp = "Surface " + Controller->FehlerVar_holen();
						PopupMenu.AppendMenu(MF_STRING, CM_PKENNFELD_FEHLER, temp.c_str());
						temp = "Active rules " + Controller->FehlerVar_holen();
						PopupMenu.AppendMenu(MF_STRING, CM_PAKTIVITAETEN_FEHLER, temp.c_str());
						temp = "Max rule activity " + Controller->FehlerVar_holen();
						PopupMenu.AppendMenu(MF_STRING, CM_PMAXAKTIVITAETEN_FEHLER, temp.c_str());
					}

					// schon Mewerte vorhanden ?
					if (Controller->
						hol_AusgabeVar().Messwerte_holen()->GetItemsInContainer()) {
						if (_Meta->Anzahl_EingabeVariable()==2) {

							// 3D-Darstellung der Mewerte mglich
							PopupMenu.AppendMenu(MF_SEPARATOR);

							temp = "Values 3D " + Controller->AusgabeVar_holen();
							PopupMenu.AppendMenu(MF_STRING, CM_PMESS3D_STEUER, temp.c_str());
							temp = "Values 3D " + Controller->FehlerVar_holen();
							PopupMenu.AppendMenu(MF_STRING, CM_PMESS3D_FEHLER, temp.c_str());
						}
					}

					// Men anzeigen
					PopupMenu.TrackPopupMenu(TPM_LEFTBUTTON,
					point.x+rect.left, point.y+rect.top,
					0,HWindow,0);
				}
				break;
			}
		}
	}
}
// Punkt checken----------------------------------------------------------------
bool TControlChild::innerhalb_Y_Bereich(TPoint& point, int ypos) {

	// berprft, ob Punkt in der Umgebung der y-Position ist
	int dy=(point.y-ypos-19);
	return max(dy,-dy) < 19;

}
bool TControlChild::innerhalb_X_Bereich(TPoint& point, int xpos) {
	// berprft, ob Punkt in der Umgebung der x-Position ist
	int dx=(point.x-xpos-19);
		return max(dx,-dx) < 19;
}
bool TControlChild::innerhalb(TPoint& point, int xpos, int ypos) {
	// berprft, ob Punkt in der Umgebung der y- und x-Position ist
	return innerhalb_Y_Bereich(point,ypos) && innerhalb_X_Bereich(point,xpos);
}

SelTyp TControlChild::Punkt_checken(TPoint& point) {

	// ermittelt anhand der y-Position den Symboltyp

	if (innerhalb_Y_Bereich(point,ypos_EingabeVar))
		return EingabeVar;
	if (innerhalb_Y_Bereich(point,ypos_Ausgabe))
		return AusgabeVar;
	if (innerhalb_Y_Bereich(point,ypos_Controller))
		return Controller;

	return kein;

}
// Objekte holen----------------------------------------------------------------
EingabeVariable* TControlChild::EingabeVariable_holen(TPoint& point) {

	// falls eine Eingabevariable im Controllereditor angeklickt wurde,
	// dann das Objekt liefern

	EingabeVariable* Ergebnis=0;

	TEingabeVarliste EingabeVarListe=_Meta->EingabeVarListe_holen();
	TEingabeVarlisteIter  Iter(EingabeVarListe);

	for (int i=0; !Ergebnis && Iter ; ++i) {
		if (innerhalb_X_Bereich(point,xpos_EingabeVar[i]))
			Ergebnis=Iter.Current();
		else
			Iter++;
	}

	return Ergebnis;
}

FController* TControlChild::Controller_holen(TPoint& point) {

	// falls ein Controller im Controllereditor angeklickt wurde,
	// dann das Objekt liefern

	FController* Ergebnis=0;

	Controllerliste ControllerListe=_Meta->ControllerListe_holen();
	ControllerlisteIter  Iter(ControllerListe);

	for (int i=0; !Ergebnis && Iter ; ++i) {
		if (innerhalb_X_Bereich(point,xpos_Controller[i]))
			Ergebnis=Iter.Current();
		else
			Iter++;
	}

	return Ergebnis;
}

AusgabeVariable* TControlChild::AusgabeVariable_holen(TPoint& point) {

	// falls eine Ausgabevariable im Controllereditor angeklickt wurde,
	// dann das Objekt liefern

	AusgabeVariable* Ergebnis=0;
	FController* Controller=0;

	Controllerliste ControllerListe=_Meta->ControllerListe_holen();
	ControllerlisteIter  Iter(ControllerListe);

	for (int i=0; !Ergebnis && Iter ; ++i) {
		if (innerhalb_X_Bereich(point,xpos_AusgabeVar[i]))
			Controller=Iter.Current();
		else
			Iter++;
	}
	if (Controller)
		Ergebnis=&Controller->_AusgabeVar;

	return Ergebnis;
}

AusgabeVariable* TControlChild::FehlerVariable_holen(TPoint& point) {

	// falls eine Fehlervariable im Controllereditor angeklickt wurde,
	// dann das Objekt liefern

	AusgabeVariable* Ergebnis=0;
	FController* Controller=0;

	Controllerliste ControllerListe=_Meta->ControllerListe_holen();
	ControllerlisteIter  Iter(ControllerListe);

	for (int i=0; !Ergebnis && Iter ; ++i) {
		if (innerhalb_X_Bereich(point,xpos_FehlerVar[i]))
			Controller=Iter.Current();
		else
			Iter++;
	}
	if (Controller)
		Ergebnis=&Controller->_FehlerVar;

	return Ergebnis;
}

void TControlChild::Pfeil(TDC& dc,FTyp& x1,FTyp& y1,FTyp& x2,FTyp& y2) {

	// zeichnet einen Pfeil (x1,y1) -> (x2,y2)

	dc.MoveTo(x1,y1);
	dc.LineTo(x2,y2);

	// Koordinaten der Pfeilspitze berechnen

	FTyp mx,my;

	mx=x2-x1;
	my=y2-y1;

	FTyp Winkel;


	FTyp l = 15;
	FTyp x3,y3,x4,y4;
	if (mx!=0.0) {
		Winkel=atan(my/mx);
		if (my>0)
			l*=-1;
		if (Winkel<0)
			l*=-1;

		x3=x2+cos(Winkel-25*180/M_PI)* l;
		y3=y2+sin(Winkel-25*180/M_PI)* l;

		x4=x2+cos(Winkel+25*180/M_PI)* l;
		y4=y2+sin(Winkel+25*180/M_PI)* l;


	}
	else {
		Winkel=90*180/M_PI;
		l*=-1.41;


		x3=x2+cos(Winkel-25*180/M_PI)* l;
		y3=y2+sin(Winkel-25*180/M_PI)* l;

		x4=x2-cos(Winkel-25*180/M_PI)* l;
		y4=y3;

	}

	// Pfeilspitze zeichnen

	dc.MoveTo(x3,y3);
	dc.LineTo(x2,y2);
	dc.LineTo(x4,y4);
	dc.LineTo(x3,y3);
}

void TControlChild::CmPCClipboard() {

	// kopiert die Darstellung in die Zwischenablage

	Invalidate(false);
	TClientDC clientDC(*this);
	TMemoryDC memDC(clientDC);
	TRect groesse=GetClientRect();

	// Bitmap erstellen

	TBitmap* bitmap=new TBitmap(clientDC,groesse.Width(),groesse.Height(),FALSE);
	memDC.SelectObject(*bitmap);
	memDC.BitBlt(0,0,groesse.Width(),groesse.Height(),clientDC,0,0,SRCCOPY);

	// in die Zwischenablage kopieren

	TClipboard &clipboard = OpenClipboard();
	clipboard.EmptyClipboard();
	bitmap->ToClipboard(clipboard);
	clipboard.CloseClipboard();

	delete bitmap;
}
void TControlChild::EvGetMinMaxInfo(MINMAXINFO  &minmaxinfo) {

	// Sorgt dafr, da der Controllereditor nicht unbegrenzt verkleinert
	// und vergrert werden kann.

	TRect parentRect;
	Parent->Parent->GetWindowRect(parentRect);

	int Breite=max(_Meta->Anzahl_Controller()*2,_Meta->Anzahl_EingabeVariable())*65;
	Breite=min(Breite,parentRect.Width());

	minmaxinfo.ptMinTrackSize.x = Breite;
	minmaxinfo.ptMinTrackSize.y = 80;
	minmaxinfo.ptMaxTrackSize.y = parentRect.Height();
	minmaxinfo.ptMaxTrackSize.x = min(Breite*1.2,(double)parentRect.Width());
}
