#ifndef _MYLIST_
#define _MYLIST_

#include <classlib/listimp.h>

template<class T>
class list {

	private:
		TListImp<T> storage;
	public:

		list();

		void append(T value);
		friend int operator==(const list<T>& left, const list<T>& right);
		friend class listIter<T>;
};

////////////////////////////////////////////////////////////////////////////////
template<class T>
class listIter{

	private:
		list<T>& S;
		TListIteratorImp<T> internalIter;

	public:

		listIter(list<T>& alist);
		T& operator++() ;
		T& operator++(int) ;

		operator int() const { return internalIter!=0;} ;

};
////////////////////////////////////////////////////////////////////////////////

template<class T>
list<T>::list() : storage() {
}

template<class T>
void list<T>::append(T value) {
	storage.Add(value);
}
template<class T>
int operator==(const list<T>& left, const list<T>& right) {

	TListIteratorImp<T> leftIter(left.storage),rightIter(right.storage);
	int result(1),cont(1);

	do {
		if (leftIter==rightIter) {
			if (leftIter==1)
				if (leftIter.Current()!=rightIter.Current())
					result=0;
		}
		else
			result=0;

		cont=(leftIter && rightIter);

		if  (cont) {
			leftIter++;
			rightIter++;
		}

	} while (result && cont) ;


	return result;
}
////////////////////////////////////////////////////////////////////////////////

template<class T>
listIter<T>::listIter(list<T>& alist) :
	S(alist), internalIter(S.storage) {
}
template<class T>
T& listIter<T>::operator++() {
	static T temp;

	if (internalIter)
		internalIter++;

	temp = internalIter.Current();

	return temp;
}

template<class T>
T& listIter<T>::operator++(int) {

	static T temp;

	temp = internalIter.Current();

	if (internalIter)
		internalIter++;

	return temp;
}

#endif
