#include "pendlchi.h"

DEFINE_RESPONSE_TABLE1(TPendelChild,TMDIChild)
	EV_WM_PAINT,
	EV_WM_SIZE,
	EV_WM_GETMINMAXINFO,
END_RESPONSE_TABLE;

TPendelChild::TPendelChild(TMDIClient& parent,
							Pendel* Pendel) : TMDIChild(parent,"Inverses Pendel") {
	_Pendel=Pendel;
	_letzter_Winkel=0;
}

void TPendelChild::berechne_Konstante(TRect& groesse) {

	_Laenge = min(groesse.Width(),groesse.Height()) / 2;
	_Radius = _Laenge / 10;
	_Mitte = groesse.left + groesse.Width() / 2;
	_Wagenhoehe = _Laenge / 5;
	_Wagenbreite = 2* _Wagenhoehe;

}
void TPendelChild::Wagen_malen() {

	TClientDC mydc(*this);
	TRect groesse=GetClientRect();



	mydc.SelectObject(TPen(TColor::Black, 1));

	// Wagen malen...
	mydc.SelectObject(TBrush(TColor::LtGray));
	mydc.Rectangle(_Mitte-_Wagenbreite,groesse.bottom,
						_Mitte+_Wagenbreite,groesse.bottom-_Wagenhoehe);


	mydc.SelectObject(TBrush(TColor::Gray));
	mydc.Ellipse(_Mitte-_Wagenbreite*4/5,groesse.bottom+_Wagenhoehe/2,
					_Mitte-_Wagenbreite*1/5,groesse.bottom-_Wagenhoehe/2);
	mydc.Ellipse(_Mitte+_Wagenbreite*4/5,groesse.bottom+_Wagenhoehe/2,
					_Mitte+_Wagenbreite*1/5,groesse.bottom-_Wagenhoehe/2);

	mydc.SelectObject(TBrush(TColor::Black));
	mydc.Ellipse(_Mitte-_Wagenbreite*2/3,groesse.bottom+_Wagenhoehe/3,
					_Mitte-_Wagenbreite*1/3,groesse.bottom-_Wagenhoehe/3);
	mydc.Ellipse(_Mitte+_Wagenbreite*2/3,groesse.bottom+_Wagenhoehe/3,
					_Mitte+_Wagenbreite*1/3,groesse.bottom-_Wagenhoehe/3);

	mydc.SelectObject(TBrush(TColor::White));
}

void TPendelChild::Malen(TDC& mydc,FTyp& Winkel, TRect& groesse, bool loeschen ) {

	if (loeschen) {
		mydc.SelectObject(TPen(TColor::White, 2));
	}
	else {
		mydc.SelectObject(TPen(TColor::Black, 2));
	}
	Winkel*=  3.145 / 180 ;

	FTyp top_x = _Mitte + sin(Winkel) * _Laenge;
	FTyp top_y = groesse.bottom - _Wagenhoehe -  cos(Winkel) * _Laenge;

	mydc.MoveTo(_Mitte,groesse.bottom-_Wagenhoehe-1);
	mydc.LineTo(top_x,top_y);
	//	mydc.Rectangle(top_x-_Radius,top_y-_Radius,top_x+_Radius,top_y+_Radius);
	if (loeschen)
		mydc.Ellipse(top_x-_Radius,top_y-_Radius,top_x+_Radius,top_y+_Radius);
	else {
		mydc.SelectStockObject(NULL_PEN);
		mydc.SelectObject(TBrush(TColor::LtBlue));
		mydc.Ellipse(top_x-_Radius,top_y-_Radius,top_x+_Radius,top_y+_Radius);

		mydc.SelectObject(TBrush(TColor::White));
		mydc.Ellipse(top_x-_Radius/2,top_y-_Radius/2,top_x+_Radius/4,top_y+_Radius/4);
		mydc.SelectStockObject(WHITE_BRUSH);
		mydc.SelectStockObject(BLACK_PEN);
	}

}
void TPendelChild::Paint(TDC&, bool, TRect& ) {
	TClientDC mydc(*this);

	TRect groesse=GetClientRect();
	mydc.SelectStockObject(NULL_PEN);
	mydc.SelectStockObject(WHITE_BRUSH);
	mydc.Rectangle(groesse);

	Wagen_malen();
	Malen(mydc,(int)_letzter_Winkel,groesse);
}
void TPendelChild::Update() {

	TClientDC mydc(*this);
	TRect groesse=GetClientRect();

	FTyp Winkel  = _Pendel->winkel();

	if (Winkel > 90)
		Winkel=90;
	else
		if (Winkel < -90)
			Winkel=-90;

	if ((int) _letzter_Winkel != (int) Winkel) {
		Malen(mydc,(int)_letzter_Winkel,groesse,true);
		Malen(mydc,(int)Winkel,groesse);
		_letzter_Winkel=Winkel;
	}
}
void TPendelChild::SetupWindow() {
	TMDIChild::SetupWindow();
	TRect parentRect;
	Parent->GetWindowRect(parentRect);


	int breite;

	if (parentRect.Width() < parentRect.Height())
		breite=parentRect.Width();
	else
		breite=parentRect.Height();

	breite /= 2;

	MoveWindow(0,0,breite,breite);
	berechne_Konstante(GetClientRect());
}

void TPendelChild::EvSize(UINT sizeType, TSize &size) {
	TMDIChild::EvSize(sizeType,size);

	berechne_Konstante(GetClientRect());
	Invalidate();
}
