#include "recwin.h"

DEFINE_RESPONSE_TABLE1(RecWin,TFrameWindow)
	EV_WM_GETMINMAXINFO,
	EV_WM_PAINT,
	EV_WM_SIZE,
	EV_COMMAND(CM_KALIBRIEREN, Kalibrieren),
END_RESPONSE_TABLE;

RecWin::RecWin(TWindow* parent,HINSTANCE hInstance)
	: TFrameWindow(parent,"Recorder") ,Server(this,hInstance) {

	// Gre des Fensters geeignet whlen
	Attr.W=185;
	Attr.H=160;
	Attr.X=
	Attr.Y=0;
}

void RecWin::Paint(TDC&, bool, TRect& ) {

	// Fenster in Symbolgre ?
	if (!IsIconic()) {
		HINSTANCE hInstance = *GetApplication();
		TClientDC mydc(*this);

		// Kassettenrekorder-Bitmap in das Fenster kopieren
		TBitmap* bitmap = new TBitmap (hInstance, BITMAP_REC);
		TMemoryDC memDC(mydc);
		memDC.SelectObject(*bitmap);
		mydc.BitBlt(3,0,
							32,32,memDC,
							0,0,
							SRCCOPY);
		delete bitmap;

		// Anzeigen beschriften
		mydc.SetTextAlign(TA_LEFT | TA_BASELINE);
		mydc.TextOut(2,30+20,
				"Abweichung",strlen("Abweichung"));
		mydc.TextOut(2,60 + 40 ,
				"Motor",strlen("Motor"));
	}
}
void RecWin::Kalibrieren() {

	// ruft die in der Arbeit beschriebene Kalibrierung auf

	SetCursor(0,IDC_WAIT);
	Server.Kalibrieren();
	MessageBeep(0);
	SetCursor(0,IDC_ARROW);
	MessageBox("Recorder ist kalibriert!","Kalibrierung");
}

void RecWin::Update() {

	// akutalisiert die Anzeigen im Fenster

	// Fenster in Symbolgre ?
	if (!IsIconic()) {
		double Abweichung,dt,Ausgabe;

		// aktuelle Werte holen
		Server.hol_Werte(Abweichung,dt,Ausgabe);

		// in Abhngigkeit der Drehzahlabweichung die Farbe der 1. Anzeige setzen
		if (Abweichung>=0)
			_Balken->SetColor(TColor::Black);
		else
			_Balken->SetColor(TColor::LtBlue);

		// nur Betrag ausgeben
		_Balken->SetValue(max(Abweichung,-Abweichung));

		// hat der Stellwert das Maximum erreicht ?
		if (Ausgabe>=63) {

			// falls ja, Anzeige rot einfrben,
			_Balken2->SetColor(TColor::LtRed);
			MessageBeep(0);
		}
		else
			// sonst grn
			_Balken2->SetColor(TColor::LtGreen);

		_Balken2->SetValue(Ausgabe);
	}
}

void RecWin::SetupWindow() {
	TFrameWindow::SetupWindow();

	// Gre des Fensters geeignet geeignet whlen

	TRect parentRect;
	GetWindowRect(parentRect);
	int xPos = parentRect.Width() / 2- 185 / 2;// + parentRect.left;
	int yPos = parentRect.Height() / 2- 160 / 2-10;// + parentRect.top;

	// Balkenanzeigen im Fenster erstellen und initialisieren

	_Balken=(new TGauge(this,"",1234,0,0,30,30,TRUE,1));
	_Balken->Create();
	_Balken->SetRange(0,60);
	_Balken->SetColor(TColor::Gray);
	_Balken->SetValue(0);
	_Balken->SetLed(3);
	_Balken->MoveWindow(2,35 + 20,149-10, 25);
	_Balken->Show(SW_SHOW);

	_Balken2=(new TGauge(this,"",1235,0,0,30,30,TRUE,1));
	_Balken2->Create();
	_Balken2->SetRange(0,63);
	_Balken2->SetColor(TColor::Gray);
	_Balken2->SetValue(0);
	_Balken2->SetLed(3);
	_Balken2->MoveWindow(2,63 + 40 ,149-10, 25);
	_Balken2->Show(SW_SHOW);
}

void RecWin::EvSize(UINT sizeType, TSize &size) {
	TFrameWindow::EvSize(sizeType,size);
	Invalidate(false);
}

void RecWin::EvGetMinMaxInfo(MINMAXINFO  & minmaxinfo) {

	// Gre des Fenster soll nicht verndert werden

	minmaxinfo.ptMinTrackSize.y = 32+40+45+20 + 40;
	minmaxinfo.ptMinTrackSize.x = 150;

	minmaxinfo.ptMaxTrackSize.y = 32+40+45+20 + 40;
	minmaxinfo.ptMaxTrackSize.x = 150;
}

RecWin::~RecWin() {

	// Balken freigeben

	delete _Balken,_Balken2;
}
//----------------------------- DDE-Server -------------------------------------
#include "ddeserv.h"

	// Rekorderfenster
	RecWin* DDEServer::_parent;

	bool DDEServer::_first,DDEServer::_very_first;

	// Anwendungsparameter
	int DDEServer::_Anwendungsstatus;
	int DDEServer::zuletzt,DDEServer::zeit_zuletzt,
			DDEServer::neu,DDEServer::zeit_neu;
	int DDEServer::Bias;
	int DDEServer::letzte_Ausgabe;
	char DDEServer::AnwendungsName[20];
	int DDEServer::Anzahl_EingabeVariable,DDEServer::Anzahl_AusgabeVariable;
	double DDEServer::Eingabewerte[MAX_EINGABEVARS];
	double DDEServer::Ausgabewerte[MAX_CONTROLLER];

	// DDE
	char DDEServer::SendePuffer[80], DDEServer::EmpfangsPuffer[80];
	HINSTANCE DDEServer::hInst;
	FARPROC DDEServer::lpDdeProc;
	DWORD DDEServer::InstId;
	DWORD DDEServer::aCbFilter;
	HCONV DDEServer::hConvApp;

	// Stringhandles
	HSZ DDEServer::hszService,DDEServer::hszTopic,DDEServer::hszItem,
			DDEServer::hszInitialisieren,
			DDEServer::hszEingabe, DDEServer::hszAusgabe,
			DDEServer::hszIdentifizieren;

DDEServer::DDEServer(RecWin* parent,HINSTANCE hInstance) {

	_parent=parent;

	// Anwendungsname und Anzahl der Ein- und Ausgabevariablen definieren
	strcpy(AnwendungsName,"Recorder");
	Anzahl_EingabeVariable=2;
	Anzahl_AusgabeVariable=1;


	hInst=hInstance;
	hConvApp	= (HCONV)NULL;
	lpDdeProc = MakeProcInstance((FARPROC)&DDEServer::DDECallback,hInst);
	InstId=0;

	// DDE initialisieren
	DdeInitialize((LPDWORD)&InstId,(PFNCALLBACK)lpDdeProc,APPCLASS_STANDARD,0L);

	// Stringhandles generieren
	hszService = 	DdeCreateStringHandle(InstId,"NEFCON-WIN",CP_WINANSI);
	hszTopic = 		DdeCreateStringHandle(InstId,"DATA-TRANSFER",CP_WINANSI);
	hszItem = 		DdeCreateStringHandle (InstId, "Data", CP_WINANSI );
	hszInitialisieren = DdeCreateStringHandle (InstId, "Init", CP_WINANSI );
	hszEingabe = DdeCreateStringHandle (InstId, "I", CP_WINANSI );
	hszAusgabe = DdeCreateStringHandle (InstId, "O", CP_WINANSI );
	hszIdentifizieren = DdeCreateStringHandle (InstId, "Ident", CP_WINANSI );

	// Name des Services initialisieren
	DdeNameService(InstId,hszService,(HSZ) NULL, DNS_REGISTER);

	Anwendung_initialisieren();
	Kalibrieren();

	_Anwendungsstatus=1; // = aktiv
}


DDEServer::~DDEServer() {

	// Service nicht mehr registrieren
	DdeNameService(InstId,hszService,NULL, DNS_UNREGISTER);

	FreeProcInstance ( lpDdeProc );

	// Stringhandles freigeben
	DdeFreeStringHandle ( InstId, hszService );
	DdeFreeStringHandle ( InstId, hszTopic );
	DdeFreeStringHandle ( InstId, hszItem );

	DdeFreeStringHandle ( InstId, hszInitialisieren );
	DdeFreeStringHandle ( InstId, hszEingabe );
	DdeFreeStringHandle ( InstId, hszAusgabe );
	DdeFreeStringHandle ( InstId, hszIdentifizieren );

	// Verbindung abmelden
	DdeUninitialize(InstId);
}


void DDEServer::Ausgabe() {

	// Stellwerte der Entwicklungsumgebung lesen

	istrstream A(EmpfangsPuffer);

	for (int i=0; i<Anzahl_AusgabeVariable; ++i) {
		A >>  Ausgabewerte[i] ;
	}
}

void DDEServer::Eingabe() {

	// Mewerte des Prozesses fr die Entwicklungsumgebung verpacken

	ostrstream E;
	for (int i=0; i<Anzahl_EingabeVariable; ++i) {
		E <<  Eingabewerte[i] << " " ;
	}
	E << _Anwendungsstatus;
	E << endl << ends;

	strcpy (SendePuffer,E.str());
	delete E.str();
}

HDDEDATA  EXPENTRY DDEServer::DDECallback ( WORD wType, WORD wFmt, HCONV hConv, HSZ hsz1,
															HSZ hsz2, HDDEDATA hData, DWORD dwData1,
														DWORD dwData2 ) {

	// DDE-Callbackfunktion fr den Prozeserver
	switch ( wType ) {

		case XTYP_CONNECT: if ( hsz2 == hszService ) {
										// Verbindung steht !
										_very_first=true;
										return ( (HDDEDATA) TRUE );
								}
								else {
									// Fehler
									return ( (HDDEDATA) FALSE );
								}
		break;

		case XTYP_REQUEST:

			// NEFCON-WIN fordert vom Prozeserver Informationen an

			// was ist gewnscht ?

			if (hsz2 == hszInitialisieren) {

				// Anwendung soll initialisiert werden
				Anwendung_initialisieren();

				// "o.k." zurckliefern
				strcpy(SendePuffer,"o.k.");

				// Datahandle fr den Sendepuffer erstellen
				hData = DdeCreateDataHandle ( InstId, (LPBYTE) DDEServer::SendePuffer,
														80,
														0L, hszItem, wFmt, 0 );

				// konnte Datahandle erstellt werden ?
				if ( hData != (HDDEDATA)NULL ) {
					// Handle an DDEML bergeben, fertig
					return ( hData );
				}
				else {
					// nein, Nullzeiger zurckliefern
					return ( (HDDEDATA)NULL );
				}
			}

			if (hsz2 == hszIdentifizieren) {

				// Prozeserver soll sich identifizieren

				// Prozeeigenschaften in den Sendepuffer schreiben
				sprintf(SendePuffer,"%s %d %d",AnwendungsName,
														Anzahl_EingabeVariable,
														Anzahl_AusgabeVariable);

				// Datahandle fr den Sendepuffer erstellen
				hData = DdeCreateDataHandle ( InstId, (LPBYTE) DDEServer::SendePuffer,
														80,
														0L, hszItem, wFmt, 0 );

				// konnte Datahandle erstellt werden ?
				if ( hData != (HDDEDATA)NULL ) {
					// Handle an DDEML bergeben, fertig
					return ( hData );
				}
				else {
					// nein, Nullzeiger zurckliefern
					return ( (HDDEDATA)NULL );
				}
			}
			else {
				if (hsz2 == hszEingabe) {

					// NEFCON-WIN wnscht neue Mewerte

					// neue Mewerte besorgen
					neue_Eingabewerte();

					// ... und in den Sendepuffer schreiben
					Eingabe();

					// Datahandle fr den Sendepuffer erstellen
					hData = DdeCreateDataHandle ( InstId, (LPBYTE) DDEServer::SendePuffer,
															80,
															0L, hszItem, wFmt, 0 );

					// konnte Datahandle erstellt werden ?
					if ( hData != (HDDEDATA)NULL ) {
						// Handle an DDEML bergeben, fertig
						return ( hData );
					}
					else {
						// nein, Nullzeiger zurckliefern
						return ( (HDDEDATA)NULL );
					}
				}
			}

		break;

		case XTYP_POKE:
			if ( hsz1 == hszTopic )
			{
				if (hsz2 == hszAusgabe) {

					// NEFCON-WIN hat neue Stellwerte bertragen

					// Data-Handle auslesen und Inhalt in den Empfangspuffer kopieren
					DdeGetData ( hData, (LPBYTE) EmpfangsPuffer, 80L, 0L );

					// Data-Handle freigeben
					DdeFreeDataHandle(hData);

					// Stellwerte aus dem Empfangspuffer lesen
					Ausgabe();

					// ... und ausgeben
					neue_Ausgabewerte();
				}
				else {

					// was auch immer im Empfangspuffer gelandet ist, ignorieren
					DdeGetData ( hData, (LPBYTE) EmpfangsPuffer, 80L, 0L );
					DdeFreeDataHandle(hData);
				}

				if ( EmpfangsPuffer != NULL ) {

					// Empfangsbesttigung senden
					return ( (HDDEDATA) DDE_FACK );
				}
			}
			else
				// sonst Nullpointer senden
				return ( (HDDEDATA) NULL );
	break;

		case XTYP_CONNECT_CONFIRM:
			// zugewiesenes Handle speichern
			hConvApp = hConv;
		break;

		case XTYP_DISCONNECT:
			// Auflsung der Verbindung mit Nullpointer quittieren
			hConvApp = (HCONV)NULL;
		break;

		// alles andere ignorieren
		case XTYP_EXECUTE:
		break;

		case XTYP_ERROR:
		break;
	}

	// sonst Nullpointer zurckgeben
	return ( (HDDEDATA) NULL );
}

void DDEServer::neue_Eingabewerte() {

	// falls erster Zyklus, Fenster in den Vordergrund bringen

	if (!_first) {
		_parent->Update();
	}
	else {
		_first=false;
		_parent->SetFocus();
	}

	if (_very_first) {
		_very_first=false;
		_parent->SetFocus();
	}

	// mindestens 1 Millisekunde mu seit der letzten Messung vergangen sein
	while((zeit_neu=GetTickCount())-zeit_zuletzt < 1 ) ;


	// neuen Drehzahlwert messen
	neu=GetByte()-Bias ;

	// numerisch diffrenzieren
	double dt=(double) (neu-zuletzt)/(double)(zeit_neu-zeit_zuletzt)*100;

	zuletzt=neu;
	zeit_zuletzt=zeit_neu;

	// Eingabewerte aktualisieren
	Eingabewerte[0]=zuletzt;
	Eingabewerte[1]=dt;
}
void DDEServer::neue_Ausgabewerte() {

	// genderte Motorspannung ausgeben

	int neue_Ausgabe=letzte_Ausgabe+Ausgabewerte[0];

	// Ausgabe auf das Intervall [0,63] begrenzen
	neue_Ausgabe=min(neue_Ausgabe,63);
	neue_Ausgabe=max(neue_Ausgabe,0);

	letzte_Ausgabe=neue_Ausgabe;

	// Spannungswert ausgeben
	WriteByte(letzte_Ausgabe);
}


void DDEServer::Anwendung_initialisieren() {

	// der Prozeserver soll initialisiert werden

	zuletzt=letzte_Ausgabe=0;
	zeit_zuletzt=GetTickCount();

	WriteByte(letzte_Ausgabe);

	// Reset der Schnittstellenkarte
	outp (RESETPORT,1 );
	int Tick=GetTickCount();
	while ((GetTickCount()-Tick) < 100);
	outp (RESETPORT,0);

	_first=true;
}

BYTE DDEServer::GetByte() {

	// Drehzahl von der Schnittstellenkarte lesen (low-level)

	while ((inp(STATUSPORTIN) & 1)==0) ;

	BYTE input = inp(DATAPORTIN) & 0x7FU;
	if (input == (BYTE)0) {
		MessageBeep(0);
		return 0;
	}
	else
		return 128 - (int)input;
}
void DDEServer::WriteByte(BYTE byte) {

	// Wert der Motospannung auf die Schnittstellenkarte ausgeben (low-level)

	if ((inp (STATUSPORTOUT) & 1) != 0)
		outp(DATAPORTOUT,63-byte);
}

void DDEServer::hol_Werte(double& Abweichung,double& dt,double& Ausgabe) {

	// Werte holen

	Abweichung=Eingabewerte[0];
	dt=Eingabewerte[1];
	Ausgabe=letzte_Ausgabe;
}

void DDEServer::Kalibrieren() {

	// Kalibrierung durchfhren (siehe Arbeit)

	WriteByte(0);
	Bias=0;
	for (int i=0;i < 100; ++i) {
		Bias=((int)GetByte()+Bias)/2;
	}
}

