#ifndef _REGEL_
#define _REGEL_

#include "AusgabeV.h"
#include "EingabeV.h"

enum Operator { Minimum, HarmonicMean, Product};

enum Verfahren {fbackprop=0,fssab,fdbd,fbackpropv,fssabv,fdbdv};
enum RegelLernVerfahren {Stellmach=0,Nauck};

typedef list<mystring> TStringliste;
typedef listIter<mystring> TStringlisteIter;

typedef list<FsSet*> TSetliste;
typedef listIter<FsSet*> TSetlisteIter;

////////////////////////////////////////////////////////////////////////////////
class Regel {

	TStringliste _Praemisse;

	TSetliste _Pointer;

	mystring _Fehlermeldung;

	mystring _Konklusion;
	Operator _Op;
	TEingabeVarliste* _EingabeVarListe;

	AusgabeVariable* _AusgabeVar;
	FTyp _letzterErfuelltheitsgrad,_Stellwert;

	FTyp _delta0,_delta,_delta_plus,_delta_minus;
	FTyp _letzter_Fehler;
	Verfahren _Verfahren;
	int _Epochen,_bisher;


public:
	// fr Naucks Regellern-Algorithmus :
	int _Cr,_used;
	FTyp _Zr;
	bool _ausgewaehlt,_verwendbar;

	Regel(TEingabeVarliste* EingabeVarListe,AusgabeVariable* AusgabeVar);

	FsSet* _AusgabeSet;

	TStringliste& Praemisse_holen() {return _Praemisse;};
	mystring& Konklusion_holen() {return _Konklusion;};

	void Operator_setzen(Operator Op);
	void Praemisse_hinzufuegen(mystring& Name);
	void Konklusion_setzen(mystring& Name);

	bool Auswertung_vorbereiten();
	mystring& hol_Fehlermeldung() {return _Fehlermeldung;};

  void Lernen_vorbereiten(Verfahren Verf, int Epochen,
									FTyp& delta,FTyp& delta_plus,FTyp& delta_minus);

  void delta_ruecksetzen();
  FTyp& Regel_auswerten(FTyp& Erfuelltheitsgrad);

  void hole_Grenzen(FTyp& x1,FTyp& x2) {_AusgabeSet->hole_Grenzen(x1,x2);};
  void Regel_adaptieren(FTyp& Fehler);

  FTyp& hol_letzten_Erfuelltheitsgrad() { return _letzterErfuelltheitsgrad;};
  FTyp& hol_Stellwert() { return _Stellwert;};

  int operator==(const Regel& mc) const;
  friend int operator > (const Regel& Regel1, const Regel& Regel2);

  friend ostream& operator << (ostream& os, Regel& eineRegel);
  friend istream& operator >> (istream& is, Regel& eineRegel);

  mystring Regel_als_String();

  inline void setze_ausgewaehlt(bool ausgewaehlt) { _ausgewaehlt=ausgewaehlt;};
  inline bool hol_ausgewaehlt() { return _ausgewaehlt;};


};

typedef list<Regel*> TRegelliste;
typedef listIter<Regel*> TRegellisteIter;

#endif