#ifndef _REGELBASIS_
#define _REGELBASIS_

#include "Regel.h"
#include "AusgabeV.h"

#include <iostream.h>


typedef list<TRegelliste*> TPraemissenContainer;
typedef listIter<TRegelliste*> TPraemissenContainerIter;

class Regelbasis {

	TPraemissenContainer _PraemissenContainer;

	TRegelliste _Regelliste;
	TEingabeVarliste* _EingabeVarListe;
	AusgabeVariable* _AusgabeVar;
	TWindow* _EditFenster;
	FTyp _Ausgabe, _alleGrade, _Ergebnis,_ErgebnisGrad,_Steuerwert;

	Operator _Op;

	Verfahren _Verfahren;
	RegelLernVerfahren _RegelLernVerfahren;

	mystring _Fehlermeldung;

	void Speicher_freigeben();
	void PraemissenContainer_freigeben();

public:

	Regelbasis(TEingabeVarliste* EingabeVarListe, AusgabeVariable* AusgabeVar,
					Operator Op=Minimum);
	~Regelbasis();

	void sortieren();

	TWindow* EditFenster_holen() {return _EditFenster;};
	void setze_EditFenster(TWindow* EditFenster) { _EditFenster=EditFenster;};

	AusgabeVariable* hol_AusgabeVariable() { return _AusgabeVar;};
	TEingabeVarliste* hol_EingabeVarListe() { return _EingabeVarListe;};


	void Operator_setzen(Operator Op);
	Operator Operator_holen() {return _Op;};
	void Regel_hinzufuegen(Regel& eineRegel);
	bool enthaelt_Regel_mit_gleicher_Praemisse(Regel& eineRegel);

	bool Auswertung_vorbereiten();
	mystring& hol_Fehlermeldung() { return _Fehlermeldung;};


	void  Lernen_vorbereiten(Verfahren Verf,RegelLernVerfahren RegelVerfahren,
										int Epochen,
										FTyp& delta,FTyp& delta_plus,FTyp& delta_minus);
	void delta_ruecksetzen();

	TRegelliste&  hol_Regelliste() { return _Regelliste;};

	FTyp& Regeln_auswerten();
	int Regelaktivitaet_bestimmen();
   FTyp MaxAktivitaet_bestimmen();
	void adaptieren(FTyp& Fehler);


	void alle_Regeln_loeschen();

	FTyp& Stellwert_des_PraemissenContainers_berechnen(bool Phase_I);

	void Regeln_lernen_I(FTyp& Fehler);
	void Regeln_lernen_Stellmach(FTyp& Fehler);

	void Regeln_lernen_II(FTyp& Fehler);
	void neue_Regelbasis_uebernehmen(FTyp& AktivierungsSchwelle);

	void entferne_Regel(Regel* eineRegel);
	bool enthaelt_Regel(Regel& test);
	void verfuegbare_FuzzySets_markieren() ;

	void Backtrack(TEingabeVarlisteIter& Iter,Regel& tempRegel);

	void PraemissenContainer_erzeugen();

	friend ostream& operator << (ostream& os, Regelbasis& eineRegelbasis);
	friend istream& operator >> (istream& is, Regelbasis& eineRegelbasis);

};

#endif