#ifndef _REGELEDIT_
#define _REGELEDIT_

#include <math.h>
#include <stdio.h>

#include <owl/mdi.h>
#include <owl/mdichild.h>
#include <owl/listbox.h>
#include <owl/combobox.h>

#include <owl/button.h>

#include <owl/dialog.h>

#include "metacntl.h"
#include "regeledt.rc"
#include "regeldlg.h"
#include "main.rc"

#define CLOSE_REGELEDIT 3

class BasisDialog : public TDialog {

	public:
		BasisDialog(TMDIChild* parent, TResId resId, Regelbasis& Basis);
		~BasisDialog();


		friend class TRegelEdit;

	private:

		Regelbasis& _Basis;
		TRegelliste& _Liste;
		TComboBox* OpBox;
		TListBox* Liste;
		TButton* ok;

		void SetupWindow();
		void Liste_erneuern();
		Regel* Regel_von_Index(int i);
		void Regel_neu();
		void Regel_loeschen();
		void Auswahl();
		void RegelAuswahl();
		DECLARE_RESPONSE_TABLE(BasisDialog);

};



class TRegelEdit : public TMDIChild{

	Regelbasis& _Basis;
	int minHoehe;
	int Buttondx,Buttondy;
	BasisDialog* _Dialog;

	public:
		 TRegelEdit(TMDIClient& parent,  BasisDialog* DialogBox,
					Regelbasis& Basis,
					mystring Name=0);

		 ~TRegelEdit();
		 void aktualisieren();
		 void SetupWindow();
		 void EvSize(UINT sizeType, TSize &size);
		 void EvGetMinMaxInfo(MINMAXINFO  & minmaxinfo);

		 bool CanClose();
		 Regelbasis& Regelbasis_holen() {return _Basis;};

		 DECLARE_RESPONSE_TABLE(TRegelEdit);

		 // ~TRegelEdit();
};
#endif