#ifndef _SETEDIT_
#define _SETEDIT_

#include <math.h>
#include <stdio.h>

#include <owl/mdi.h>
#include <owl/mdichild.h>

#include "metacntl.h"
#include "lineal.h"
#include "main.rc"

#include "fuzzydlg.h"
#include "partdlg.h"

#define RAND_LINKS 50
#define RAND_RECHTS 50
#define RAND_OBEN 30
#define RAND_UNTEN 30

#define FANG_Y 10
#define FANGRADIUS 10

#define CLOSE_SETEDIT 2

#define CM_PFEIGENSCHAFTEN 6000
#define CM_PFLOESCHEN 		6001
#define CM_PFHINZUFUEGEN 	6002
#define CM_PFCLIPBOARD 		6003

#define CM_PPARTITION 		6004

enum TModus {links,mitte,rechts};

class TSetEdit : public TMDIChild{

	FController* _Controller;
	mystring _Name;
	Variable* _Var;
	FTyp _min,_max;

	ContainerType* _FuzzySets;

	FsSet* _Set, *_InfoSet;

	FsSet _neues_Set;
	TPoint _letzter_gueltiger_Punkt,_Startpunkt;
	TModus _Modus;
	FTyp _Pixel_x;
	TFont* _Schrift;

	bool _ist_AusgabeVar,_ist_FehlerVar;

	TRect berechne_Bildviereck(TRect& groesse);

	int ist_innerhalb(TRect& bild, TPoint punkt);
	int ist_oben(TRect& bild, TPoint& punkt);
	int ist_unten(TRect& bild, TPoint& punkt);

	FTyp berechne_Distanz(const FsSet* Set,FTyp& x,FTyp& y);

	TPoint projiziere(TRect& bild, FTyp& x ,FTyp& y);
	FTyp Distanz(TDC& dc,TRect& bild, TPoint punkt, const FsSet* Set);
	void ueberpruefe_Ecke(const FsSet* Set ,FTyp& x,FTyp& y,
										FTyp& beste_Distanz, FTyp& x1,FTyp& x2);
	const FsSet* hol_selektiertes_Set(TDC& dc,TRect& bild, TPoint& punkt);

	void wiederherstellen(const FsSet* QuellSet,FsSet& Set,TDC& dc,TRect& bild);

	void male_X_Achse(TDC& dc,TRect& bild, bool alles=true);
	void male_Y_Achse(TDC& dc,TRect& bild, bool alles=true);

	void Paint(TDC& , bool, TRect& );
	void SetupWindow();

	void EvSize(UINT, TSize&);
	void EvRButtonUp(UINT, TPoint& point);
	void EvRButtonDown(UINT, TPoint&);
	void EvRButtonDblClk(UINT, TPoint&);
	void EvMouseMove(UINT, TPoint&);
	void EvLButtonUp(UINT, TPoint&);
	void Info(FsSet* Set);
	void Titel();
	bool CanClose();


	void CmPFEigenschaften();

	void CmPFLoeschen();
	void CmPFHinzufuegen();
	void CmPFClipboard();

	void CmPPartition();
	void partitionieren(bool Dreiecke_erlaubt, int Anzahl);
   mystring Name_bestimmen(bool positiv,int Nr);
	void einfuegen(bool positiv,int Anzahl,bool Dreiecke_erlaubt);
	void einfuegen_positiv(FTyp x0,FTyp& Intervalllaenge,
									int Anzahl,bool Dreiecke_erlaubt);
	void einfuegen_negativ(FTyp x0,FTyp& Intervalllaenge,
									int Anzahl,bool Dreiecke_erlaubt);


	public:
		 TSetEdit(TMDIClient& parent,
					FController* Controller,
					mystring& Name,
					bool ist_AusgabeVar=false,bool ist_FehlerVar=false);

		TSetEdit(TMDIClient& parent,
					Variable* Var,
					bool ist_AusgabeVar=false,bool ist_FehlerVar=false);

		 void initialisieren();
		 Variable* Var_holen() { return _Var;};

		 DECLARE_RESPONSE_TABLE(TSetEdit);

		 ~TSetEdit();
};
#endif
