#include "surface.h"

#define FARBEN_PRO_SCHEMA 25
DEFINE_RESPONSE_TABLE1(TSurfaceMDIChild, TMDIChild)
	EV_WM_RBUTTONDBLCLK,
	EV_WM_LBUTTONUP,
	EV_WM_SIZE,
	EV_COMMAND(CM_DIALOG, CmDialog),
	EV_COMMAND(CM_CLIPBOARD, CmClipboard),
	EV_COMMAND(CM_SAKTUALISIEREN, CmSAktualisieren),
	EV_COMMAND(CM_PEXPORT, CmPExport),
	EV_WM_PALETTECHANGED,
END_RESPONSE_TABLE;

TSurfaceMDIChild::TSurfaceMDIChild(TMDIClient& parent,  TPalette* Palette,
												FController* Controller,bool Fehler) :
					dreidchild(parent,Palette),
					 _Controller(Controller),
					 bitmap(0), memDC(0) {

	_Palette=Palette;

	// Liste der Eingabevariablen holen
	_EingabeVarListe=Controller->EingabeVarListe_holen();
	TEingabeVarlisteIter Iter(_EingabeVarListe);

	// die beiden Eingabevariablen speichern
	Var1=Iter.Current();
	Iter++;
	Var2=Iter.Current();

	xmin_alt=xmax_alt=zmin_alt=zmax_alt=0;

	// zu zeichnende Bereiche holen
	xmin=Var1->min_holen();
	xmax=Var1->max_holen();

	zmin=Var2->min_holen();
	zmax=Var2->max_holen();

	_mitGitter=false;

	// speichern, ob das Kennfeld des erweiterten Fehlers gezeichnet werden soll
	_Fehler=Fehler;

	// bentigte Puffer dynamisch allozieren
	_KennfeldPuffer=new aBuffer();
	_Projektx=new aBuffer();
	_Projekty=new aBuffer();
	_RotPuffer  = new intBuffer();
	_GruenPuffer= new intBuffer();
	_BlauPuffer = new intBuffer();
	_IndexPuffer = new intBuffer();

	_dxalt=_dyalt=0;
	buffer_aktuell=false;

	// entsprechendes Farbschema initialisieren
	if (Fehler) {
		_Farbschema=rot;
	}
	else {
		_Farbschema=gruen;
	}


	setze_Aufloesung(25);

	// Farbschemata geeinget initialisieren
	FaktorRot  [blau] =  125;
	FaktorGruen[blau] = 155;
	FaktorBlau [blau] =  255;
	BiasRot  [blau] = 0;
	BiasGruen[blau] = 0;
	BiasBlau [blau] = 0;

	FaktorRot  [gelbblau] = 255;
	FaktorGruen[gelbblau] = 240;
	FaktorBlau [gelbblau] = -100;
	BiasRot  [gelbblau] = 0;
	BiasGruen[gelbblau] = 0;
	BiasBlau [gelbblau] = 255;


	FaktorRot  [sgruen] = -90;
	FaktorGruen[sgruen] = 140;
	FaktorBlau [sgruen] = 180;
	BiasRot  [sgruen] = 140;
	BiasGruen[sgruen] = 0;
	BiasBlau [sgruen] = 0;


	FaktorRot  [rot] = 255;
	FaktorGruen[rot] = 40;
	FaktorBlau [rot] = 80;
	BiasRot  [rot] = 0;
	BiasGruen[rot] = 0;
	BiasBlau [rot] = 0;

	FaktorRot  [grau] = 255;
	FaktorGruen[grau] = 255;
	FaktorBlau [grau] = 255;
	BiasRot  [grau] = 0;
	BiasGruen[grau] = 0;
	BiasBlau [grau] = 0;

	FaktorRot  [orange] = 255;
	FaktorGruen[orange] = 135;
	FaktorBlau [orange] = 100;
	BiasRot  [orange] = 0;
	BiasGruen[orange] = 0;
	BiasBlau [orange] = 0;


	FaktorRot  [gruen] =  100;
	FaktorGruen[gruen] = 255;
	FaktorBlau [gruen] =  155;
	BiasRot  [gruen] = 0;
	BiasGruen[gruen] = 0;
	BiasBlau [gruen] = 0;
}

void TSurfaceMDIChild::SetupWindow() {

	dreidchild::SetupWindow();

	// Konstante fr Projektionen und Transformationen berechnen
	Konstante_berechnen();


	// Gre des Fensters geeignet whlen
	TRect parentRect;
	Parent->GetWindowRect(parentRect);

	int breite;

	if (parentRect.Width() < parentRect.Height())
		breite=parentRect.Width();
	else
		breite=parentRect.Height();

	breite /= 3;

	SetIcon(GetApplication(),ICON_ZEICHNE);
	MoveWindow(30,30,breite,breite);

}
void TSurfaceMDIChild::setze_Aufloesung(int Aufloesung) {
	steps=Aufloesung;
	stepx=(xmax-xmin)/steps;
	stepz=(zmax-zmin)/steps;
}


void TSurfaceMDIChild::berechne_Schattierungen() {


	int x,z;

	// Paramter fr das aktuelle Farbschema ermitteln
	FTyp 	rotf(FaktorRot[_Farbschema]),
			gruenf(FaktorGruen[_Farbschema]),
			blauf(FaktorBlau[_Farbschema]);

	FTyp 	rotb(BiasRot[_Farbschema]),
			gruenb(BiasGruen[_Farbschema]),
			blaub(BiasBlau[_Farbschema]);

	// konstante Terme vorbesetzen
	vx=stepx;
	wz=stepz;
	py=-vx*wz;
	FTyp lx2;

		for (x=0; x<steps; ++x) {
			p1x=xmin+x*stepx;
			lx=p1x-lqx;
			lx2=lx*lx;

			for (z=steps-1; z>=0; --z) {

				// Farbe des Polygons ermitteln,
				// eine Beschreibung des Algorithmus findet man in der Arbeit

				p1y=_KennfeldPuffer->buffer[x][z];
				p1z=zmin+z*stepz;

				vy=_KennfeldPuffer->buffer[x+1][z] - p1y;

				wy=_KennfeldPuffer->buffer[x][z+1] - p1y;

				px=vy*wz;
				pz=vx*wy;

				ly=p1y-lqy;
				lz=p1z-lqz;

				cosa=(px*px+py*py+pz*pz);
				cosa*=(lx2+ly*ly+lz*lz);
				cosa=(px*lx+py*ly+pz*lz)/sqrt(cosa);

				FTyp farb=0.3;
				FTyp Hoehe= (p1y-ymin)/(ymax-ymin);

				if (cosa < 0) {
					farb-=0.7*cosa;

					// diese Puffer werden fr Echtfarbdarstellungen verwendet
					_RotPuffer->buffer[x][z] = min((double)255,  (rotb + rotf * 0.5 *(farb + Hoehe)));
					_GruenPuffer->buffer[x][z] = min((double)255,(gruenb + gruenf * 0.5 *(farb + Hoehe)));
					_BlauPuffer->buffer[x][z] = min((double)255, (blaub + blauf * 0.5 * (farb + Hoehe)));
				}
				else {
					farb = 0;
					// s.o.
					_RotPuffer->buffer[x][z] =
					_GruenPuffer->buffer[x][z] =
					_BlauPuffer->buffer[x][z] = 0;
				}
				// IndexPuffer wird fr Darstellungen im 256-Farben Modus herangezogen
				_IndexPuffer->buffer[x][z]=(int)(0.5*((p1y-ymin)/(ymax-ymin)*FARBEN_PRO_SCHEMA+farb*FARBEN_PRO_SCHEMA));
			}
		}
}

bool TSurfaceMDIChild::check_Kennfeld() {

	FTyp y;

	if (!buffer_aktuell) {

		if (!_Controller->Auswertung_vorbereiten()) {

			// falls bei der Vorbereitung ein Fehler aufgetreten ist, abbrechen
			ymin=ymax=0;
			MessageBox(_Controller->hol_Fehlermeldung().c_str(),"Error",  MB_OK | MB_ICONSTOP);
			for (FTyp xc(0); xc<=steps; ++xc)
				for (FTyp zc(0); zc<=steps; ++zc)
					_KennfeldPuffer->buffer[(int)xc][(int)zc]=0;
		}
		else {

		// Wartebox zeichnen
		Parent->SetCursor(0,IDC_WAIT);
		TWarteBox warte(this,DIALOG_WARTE,"calculating...",TColor::LtRed);
		warte.Create();
		warte.Show(SW_SHOW);

		// Array berechnen
		FTyp zwert;
		int zci,xci;
		xci=0;
		for (FTyp xc(0); xc<=steps; ++xc,++xci) {

			Var1->setze_Eingabewert(min(xmin+stepx*xc,xmax));

			zwert=zmin;
			zci=0;
			for (FTyp zc(0); zc<=steps; ++zc,zwert+=stepz,++zci ) {

				Var2->setze_Eingabewert(min(zwert,zmax));

				// Fehler bzw. Stellwert
				// in Abhngigkeit der Eingabevariablen ermitteln

				if (_Fehler)
					y=_Controller->Fehler_berechnen();
				else {
					_Controller->Stellwert_berechnen();
					y=_Controller->Stellwert_holen();
				}

				// Minimum und Maximum von y ber das Array bestimmen
				if(xc==0 && zc==0)
					ymax=ymin=y;
				else  {
					if (y<ymin) {
						ymin=y;
					}
					if (y>ymax) {
						ymax=y;
					}
				}

				_KennfeldPuffer->buffer[xci][zci]=y;

			}

			// Wartebox aktualisieren
			if (!(xci % 2))
				warte.SetValue((xc+1)/steps*100);
		}


		// Wartebox schlieen

		warte.CloseWindow();

		Parent->SetCursor(0,IDC_ARROW);

		}


		// Abfrage, ob alle Arrayeintrge identisch

		if (ymin==ymax) {

			if (ymin==0) {

				ymax=1;

				ymin=-1;

			}

			else {

				FTyp dy;

				if (ymin<0)

					dy=-ymin;

				else

					dy=ymin;


				ymin-=dy;

				ymax+=dy;

			}

		}


		// Schattierungen berechnen

		berechne_Schattierungen();

		buffer_aktuell=true;
		_dxalt=0;

		return true;
	}

	return false;

}
bool TSurfaceMDIChild::check_Projektion(TRect& groesse) {

	int x,z;
	FTyp dx,dy,xe1,ye1;

	// Gre des Fensters ermitteln
	dx=groesse.right-groesse.left;
	dy=groesse.bottom-groesse.top;


	// Hat sich die Gre verndert ?
	if (dx!=_dxalt || dy!=_dyalt) {

		// falls ja, neu projizieren
		TWarteBox warte(this,DIALOG_WARTE,"projecting...",TColor::LtYellow);

		warte.Create();
		warte.Show(SW_SHOW);

		// 1. skalieren
		neu_skalieren(dx,dy);


		// 2. projizieren

		_dxalt=dx;
		_dyalt=dy;

		for (x=0; x<=steps; ++x) {
			warte.SetValue(x/steps*100);
			for (z=steps; z>=0; --z) {

				// Koordinaten ermitteln
				projiziere(xmin+x*stepx,
								_KennfeldPuffer->buffer[x][z],
								zmin+z*stepz,xe1,ye1);

				// und fr die weitere Verarbeitung speichern
				_Projektx->buffer[x][z]=xe1;
				_Projekty->buffer[x][z]=ye1;
			}

		}
		// Wartebox schlieen
		warte.CloseWindow();
		return true;
	}
	return false;
}

void TSurfaceMDIChild::EvSize(UINT sizeType, TSize& Size) {
	TMDIChild::EvSize(sizeType,Size);
	Invalidate(false);
}

void TSurfaceMDIChild::Kennfeld_zeichnen(TRect& groesse) {
	TClientDC mydc(*this);
	Parent->SetCursor(0,IDC_WAIT);

		// falls eine Bitmap vorhanden ist, diese verwerfen,
		// da die Darstellung nicht mehr aktuell ist
		if (bitmap) {
			delete bitmap;
			bitmap =0;
		}

		// neue Bitmap anfordern
		bitmap = new TBitmap(mydc, groesse.Width(),groesse.Height(),true);
		memDC=   new TMemoryDC(mydc);

		// Wartebox zeichnen
		TWarteBox warte(this,DIALOG_WARTE,"drawing...",TColor::LtGreen);
		warte.Create();
		warte.Show(SW_SHOW);

		// falls kein Echtfarbmodus, Palette benutzen
		if (_Palette_benutzen)
			memDC->SelectObject(*Palette);


		memDC->SelectObject(*bitmap);


		memDC->SelectStockObject(WHITE_PEN);
		memDC->SelectStockObject(WHITE_BRUSH);
		memDC->Rectangle(groesse);
		memDC->SelectStockObject(BLACK_PEN);

		// Achsen, erster Teil ("hinten")
		male_Achsen(*memDC);

		TPoint punkte[4];


		if (_mitGitter)
			memDC->SelectStockObject(BLACK_PEN);
		else
			memDC->SelectStockObject(NULL_PEN);

		int x,z;
		// Zeiger fr den Arrayzugriff, aus Performancegrnden
		int  *rotzeiger, *gruenzeiger,*blauzeiger;
		int *indexzeiger;
		FTyp	*xzeiger1,*xzeiger2,*xzeiger3,*xzeiger4,
				*yzeiger1,*yzeiger2,*yzeiger3,*yzeiger4;

		int palindex_offset=_Farbschema*FARBEN_PRO_SCHEMA;

		// Pinsel fr die Farben des verwendeten Farbschemas
		TBrush *Pinsel[FARBEN_PRO_SCHEMA];

		if (_Palette_benutzen)
			for (int i=0; i<FARBEN_PRO_SCHEMA; ++i) {
				// Pinsel erstellen
				Pinsel[i]=new TBrush(TColor(palindex_offset+i));
			}

		for (x=0; x<steps; ++x) {

			// Zeiger fr die aktuelle Zeile erstellen
			rotzeiger = &_RotPuffer->buffer[x][(int)steps-1];
			gruenzeiger = &_GruenPuffer->buffer[x][(int)steps-1];
			blauzeiger = &_BlauPuffer->buffer[x][(int)steps-1];
			xzeiger1 = &_Projektx->buffer[x][(int)steps-1];
			xzeiger2 = &_Projektx->buffer[x+1][(int)steps-1];
			xzeiger3 = &_Projektx->buffer[x+1][(int)steps];
			xzeiger4 = &_Projektx->buffer[x][(int)steps];

			yzeiger1 = &_Projekty->buffer[x][(int)steps-1];
			yzeiger2 = &_Projekty->buffer[x+1][(int)steps-1];
			yzeiger3 = &_Projekty->buffer[x+1][(int)steps];
			yzeiger4 = &_Projekty->buffer[x][(int)steps];

			indexzeiger= &_IndexPuffer->buffer[x][(int)steps-1];

			// Wartebox aktualisieren
			if (!(x%2))
				warte.SetValue(x/steps*100);

			for (z=steps-1; z>=0; --z) {

				if (_Palette_benutzen)
					// im 256-Farben Modus gespeicherte Pinsel verwenden
					// (da nur begrenzte Anzahl von Farben)
					memDC->SelectObject(*Pinsel[*indexzeiger--]);
				else
					// im Echtfarbmodus mu Pinsel individuell erstellt werden
					memDC->SelectObject(TBrush(TColor(*rotzeiger--,
																*gruenzeiger--,
																*blauzeiger--)));

				// Punkte fr zu zeichnendes Polygon aus dem Array initialisieren
				punkte[0].x = *xzeiger1--;
				punkte[0].y = *yzeiger1--;
				punkte[1].x = *xzeiger2--;
				punkte[1].y = *yzeiger2--;
				punkte[2].x = *xzeiger3--;
				punkte[2].y = *yzeiger3--;
				punkte[3].x = *xzeiger4--;
				punkte[3].y = *yzeiger4--;

				// Polygon zeichnen
				memDC->Polygon(punkte,4);
			}
		}

		// zum Schlu restliche Achsen ("vorn") zeichen
		male_restliche_Achsen(*memDC);

		// fertig, Bitmap in das Fenster kopieren
		mydc.BitBlt(0,0, bitmap->Width(), bitmap->Height(),
					*memDC,groesse.left,groesse.top,SRCCOPY);

		delete memDC;

		// falls Pinsel verwendet, Pinsel deallozieren
		if (_Palette_benutzen)
			for (int j=0; j<FARBEN_PRO_SCHEMA; ++j) {
				delete Pinsel[j];
			}

		// Wartebox entfernen
		warte.CloseWindow();
		Parent->SetCursor(0,IDC_ARROW);
}

void TSurfaceMDIChild::Paint (TDC& paintdc, BOOL, TRect& ){



	FTyp xe1,ye1,xe2,ye2;

	TRect groesse=GetClientRect();
	TClientDC mydc(*this);

	// Falls kein Echtfarbmodus, Palette benutzen
	if (_Palette_benutzen) {
		mydc.SelectObject(*_Palette);
	}

	// zu zeichnende Bereiche der Variablen holen
	xmin=Var1->min_holen();
	xmax=Var1->max_holen();

	zmin=Var2->min_holen();
	zmax=Var2->max_holen();

	// wurden sie gendert ?
	bool result0=(xmin != xmin_alt) || (xmax != xmax_alt) ||

						(zmin != zmin_alt) || (zmax != zmax_alt) ;

	// falls ja, neu berechnen
	if (result0) {
		zmin_alt=zmin;
		zmax_alt=zmax;
		xmin_alt=xmin;
		xmax_alt=xmax;
		buffer_aktuell=false;
		_dxalt=_dyalt=0;
		stepx=(xmax-xmin)/steps;
		stepz=(zmax-zmin)/steps;
	}

	// haben sich die Namen der Variablen gendert ?
	bool result3=(Var1->Name()!=_Var1) || (Var2->Name()!=_Var2);

	if (_Fehler) {
		result3= result3 || (_stellgroesse_name!=_Controller->FehlerVar_holen());
	}
	else {
		result3= result3 || (_stellgroesse_name!=_Controller->AusgabeVar_holen());
	}
	if (result3) {

		// falls ja, neuen Titel konstruieren
		_Var1=Var1->Name();
		_Var2=Var2->Name();
		mystring Titel("Surface - ");
		if (_Fehler)
			_stellgroesse_name=_Controller->FehlerVar_holen();
		else
			_stellgroesse_name=_Controller->AusgabeVar_holen();
		Titel+=_stellgroesse_name;
		SetCaption(Titel.c_str());
	}
	// berprfen, ob das Array und die Projektion noch aktuell sind
	bool result1=check_Kennfeld();
	bool result2=check_Projektion(groesse);

	// alles noch aktuell ?
	if (!(result3 || result2 || result1 || result0) && bitmap) {

      // falls ja, dann wird nur die bereits gezeichnete Bitmap in das
		// Fenster kopiert

		memDC=new TMemoryDC(mydc);

		if (_Palette_benutzen)
			memDC->SelectObject(*Palette);

		memDC->SelectObject(*bitmap);
		paintdc.BitBlt(0,0, bitmap->Width(), bitmap->Height(),
							*memDC,0,0,SRCCOPY);

		if (_Palette_benutzen)
			memDC->RestorePalette();

		delete memDC;
	}
	else {
   	// ansonsten mu das Kennfeld neu gezeichnet werden
		Kennfeld_zeichnen(groesse);
	 }
}

void TSurfaceMDIChild::EvLButtonUp(UINT, TPoint& point) {

	TPopupMenu PopupMenu;
	TRect rect;
	GetWindowRect(rect);

	// Menu konstruieren
	PopupMenu.AppendMenu(MF_STRING, CM_CLIPBOARD, "Copy into clipboard");
	PopupMenu.AppendMenu(MF_STRING, CM_PEXPORT, "Export data to file...");
	PopupMenu.AppendMenu(MF_SEPARATOR);
	PopupMenu.AppendMenu(MF_STRING, CM_SAKTUALISIEREN, "Update");
	PopupMenu.AppendMenu(MF_SEPARATOR);
	PopupMenu.AppendMenu(MF_STRING, CM_DIALOG, "Properties...");

	// Menu anzeigen
	PopupMenu.TrackPopupMenu(TPM_LEFTBUTTON,
										point.x+rect.left, point.y+rect.top,
										0,HWindow,0);

}

void TSurfaceMDIChild::EvRButtonDblClk(UINT, TPoint&) {
	CmSAktualisieren();
}


void TSurfaceMDIChild::CmDialog() {

	//Dialog erzeugen
	TKennfeldDialog* DialogEinstellungen=
		new TKennfeldDialog(this,steps,_mitGitter,_Farbschema);

	// und ausfhren
	DialogEinstellungen->Execute();

	bool neuzeichnen(false);

	// neue Auflsung ermitteln
	int neue_Aufloesung= DialogEinstellungen->hol_Aufloesung();

	// hat sie sich verndert ?
	if (neue_Aufloesung!=steps) {

		// falls ja, ist die Darstellung nicht mehr aktuell
		setze_Aufloesung(neue_Aufloesung);
		buffer_aktuell=false;
		neuzeichnen=true;
	}

	// soll das Gitter mitgezeichnet werden  ?
	bool mitGitter= DialogEinstellungen->hol_Gitter();

	// hat sich das gendert ?
	if (mitGitter!=_mitGitter) {

		// falls ja, neuzeichnen
		_mitGitter=mitGitter;
		neuzeichnen=true;
	}

	// gewnschtes Farbschema ermitteln
	Farbschema neuesSchema= DialogEinstellungen->hol_Schema();

	// hat es sich gendert ?
	if (neuesSchema!=_Farbschema) {
		// falls ja, neuzeichnen
		_Farbschema=neuesSchema;

		if (!_Palette_benutzen)
			// bei Echtfarbdarstellung mssen die Farbpuffer neu berechnet werden
			berechne_Schattierungen();

		neuzeichnen=true;
	}

	// falls neuzeichnen, alte gespeicherte Darstellung verwerfen
	if (neuzeichnen) {
		Invalidate(false);
		if (bitmap) {
			delete bitmap;
			bitmap=0;
		}
	}

	// Dialogbox freigeben
	delete  DialogEinstellungen;
}

void TSurfaceMDIChild::CmClipboard() {

	// Bitmap in das Clipboard kopieren
	TClipboard &clipboard = OpenClipboard();
	clipboard.EmptyClipboard();
	bitmap->ToClipboard(clipboard);
	clipboard.CloseClipboard();
}

void TSurfaceMDIChild::CmSAktualisieren() {
	buffer_aktuell=false;
	Invalidate(false);
}

void TSurfaceMDIChild::EvPaletteChanged(HWND hWndPalChg) {
	TClientDC(*this).UpdateColors();
}

void TSurfaceMDIChild::CmPExport() {

	// exportiert das Kennfeld in eine Datei (ASCII)

	// Speicherdialog  initialisieren und ausfhren
	TOpenSaveDialog::TData fileData(OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,
			"ASCII Files(*.dat)|*.dat",0,0,"dat");
	  strcpy(fileData.FileName,"surface.dat");
	TFileSaveDialog *dialog= new TFileSaveDialog(this,fileData);
	int result= dialog->Execute();
	delete dialog;

	if (result==IDOK) {

		Parent->SetCursor(0,IDC_WAIT);

		// Dateiname ermitteln
		ofstream of(fileData.FileName);

		FTyp zwert;
		int zci,xci;
		xci=0;

		// Arraywerte ausgeben
		for (FTyp xc(0); xc<=steps; ++xc,++xci) {
			zwert=zmin;
			zci=0;
			for (FTyp zc(0); zc<=steps; ++zc,zwert+=stepz,++zci ) {

				of << min(xmin+stepx*xc,xmax) << " ";
				of << min(zwert,zmax) << " ";
				of << _KennfeldPuffer->buffer[xci][zci] << endl;
			}
		}
		of.close();

		Parent->SetCursor(0,IDC_ARROW);
	}
}


TSurfaceMDIChild::~TSurfaceMDIChild() {

	// alle allozierten Puffer freigeben
	delete _KennfeldPuffer;
	delete _Projektx;
	delete _Projekty;

	delete _RotPuffer;
	delete _GruenPuffer;
	delete _BlauPuffer;

	delete _IndexPuffer;

	// falls Bitmap verwendet, freigeben
	if (bitmap)
		delete bitmap;
}



