#include "vardlg.h"

DEFINE_RESPONSE_TABLE1(VarDialog, TCenterDialog)
	EV_CHILD_NOTIFY(IDCANCEL, BN_CLICKED, Abbruch),
	EV_CHILD_NOTIFY(IDOK, BN_CLICKED, Uebernehmen),
END_RESPONSE_TABLE;

VarDialog::VarDialog(TWindow* parent,MetaController* Meta,Variable* Var,
							bool istEingabeVar) : TCenterDialog (parent,DIALOG_VAR),
	_Var(Var), _Meta(Meta), _istEingabeVar(istEingabeVar) {

	neue_Grenzen=neuer_Name=false;

	// Edit-Fenster konstruieren
	min= new TEdit(this,IDC_MIN,16);
	max= new TEdit(this,IDC_MAX,16);
	_Name= new TEdit(this,IDC_NAME,30);
}

void VarDialog::SetupWindow() {

	TCenterDialog::SetupWindow();

	// aktueller Definitionsbereich holen
	FTyp VarMin=_Var->min_holen();
	FTyp VarMax=_Var->max_holen();

	char puffer[30];

	// Fenster mit diesen Werten initialisieren
	sprintf(puffer,"%.2f",VarMin);
	min->SetText(puffer);
	sprintf(puffer,"%.2f",VarMax);
	max->SetText(puffer);

	// Name der Variable in das Fenster schreiben
	_Name->SetText(_Var->Name().c_str());


}

void VarDialog::Abbruch() {
	CloseWindow();
}
void VarDialog::Uebernehmen() {

	bool ok=true;

	// neuer Name der Variable ermitteln
	char puffer[100];
	_Name->GetText((char *)&puffer,30);

	istrstream is(puffer);

	mystring neu(puffer),neu2,alt;
	alt = _Var->Name();

	is >> neu2;
	// besteht Name aus einem einzigen Wort ?
	if (neu2!=neu) {
		MessageBox("Names mustn't consist of more then one single word.","Error");
		ok=false;
	}

	// hat sich der Name gendert ?
	if (neu!=alt) {
		// ist die Variable eine Eingabevariable ?
		if (_istEingabeVar) {
			// falls ja, existiert schon eine Eingabevariable mit gleichem Namen ?
			if (_Meta->existiert_EingabeVar(neu)) {
				MessageBox("There's already a variable existing with this name.","Error");
				ok=false;
			}
			else {
				// falls nein, aktuelle Variable umbenennen
				_Meta->EingabeVar_umbenennen(alt,neu);
				neuer_Name=true;
			}
		}
		else {
			// neuer Name der Ausgabevariablen setzen
			_Var->setze_Name(neu);
			neuer_Name=true;
		}
	}

	// neue Grenzen des Definitionsbereichs lesen
	FTyp neumin,neumax,Grenzemin,Grenzemax;

	min->GetText((char *)&puffer,30);
	neumin=atof(puffer);
	max->GetText((char *)&puffer,30);
	neumax=atof(puffer);

	_Var->hol_definierte_Grenzen(Grenzemin,Grenzemax);

	// falls ntig, tauschen
	if (neumin > neumax) {
		FTyp temp=neumax;
		neumax=neumin;
		neumin=temp;
	}
	// soll der Definitionsbereich verkleinert werden, obwohl bereits Fuzzy-Mengen
	// darauf definiert sind ?
	if (Grenzemin < neumin || Grenzemax > neumax) {
		// falls ja , Fehler
		sprintf(puffer,"Fuzzy-sets already defined in [%.2f,%.2f].",Grenzemin,Grenzemax);
		MessageBox(puffer,"Error");
		ok=false;
	}
	else {
		// sonst neue Grenzen zuweisen
		_Var->setze_min_max(neumin,neumax);
		neue_Grenzen=true;
	}

	if (ok)
		CloseWindow();
}

VarDialog::~VarDialog() {

	// allozierte Dialogelemente wieder freigeben
	delete min;
	delete max;
	delete _Name;

}

