#ifndef _VARIABLE_
#define _VARIABLE_

#include "FsSet.h"

#include "mystring.h"
#include "mylist.h"

#include <classlib/assoc.h>
#include <classlib/dict.h>

#include "owl/window.h"

typedef TIIAssociation<mystring, FsSet> AssociationType;
typedef TDictionaryAsHashTable<AssociationType> ContainerType;
typedef TDictionaryAsHashTableIterator<AssociationType> IteratorType;

typedef list<FTyp> MesswerteListe ;
typedef listIter<FTyp> MesswerteIter;

class Variable {
	TWindow* _EditFenster;
	FTyp _min,_max;

protected:
	mystring _Name;
	ContainerType _FuzzySets;

	void Speicher_freigeben();
	MesswerteListe _Messwerte;

public:
  Variable();
  ~Variable();
  Variable(mystring& Name, FTyp& min, FTyp& max);

  TWindow* EditFenster_holen() {return _EditFenster;};
  void setze_EditFenster(TWindow* EditFenster) { _EditFenster=EditFenster;};

  mystring& Name();
  void setze_Name(mystring& Name) {_Name=Name;};

  void hol_definierte_Grenzen(FTyp& min,FTyp& max);
  void setze_min_max(FTyp& min, FTyp& max) { _min=min;_max=max;};
  ContainerType* FuzzySets_holen();

  void alle_FuzzySets_loeschen();

  inline FTyp min_holen() { return _min; }
  inline FTyp max_holen() { return _max; }


  void FuzzySet_einfuegen(mystring& Name, FTyp x1, FTyp x2,
								FTyp min_x, FTyp max_x);
  void FuzzySet_einfuegen(mystring& Name, FTyp x1, FTyp x2, FTyp x3,
								FTyp min_x, FTyp max_x);

  void FuzzySet_setze_Grenze(mystring& Name, FTyp x1, FTyp x2);

  bool ex_Set(mystring& Name);

  FsSet* hol_Set(mystring& Name);

  void Messwerte_loeschen() { _Messwerte.Flush();};
  MesswerteListe* Messwerte_holen() { return &_Messwerte;};

  friend ostream& operator << (ostream& os, Variable& aVar);
  friend istream& operator >> (istream& is, Variable& aVar);

};
#endif