#include "wartebox.h"

#define wx 150
#define wy 25

TWarteBox::TWarteBox(TWindow* parent, TResId id, char* title, TColor Farbe)
	: TWindow (parent,"busy") {
	Attr.W=wx;
	Attr.H=wy;

	Attr.Style |= WS_BORDER;

	_Titel=title;

	_Farbe=Farbe;

}
void TWarteBox::SetupWindow() {

	TWindow::SetupWindow();

	// Gre und Position der Wartebox geeignet bestimmen
	TRect parentRect;
	Parent->GetWindowRect(parentRect);
	int xPos = parentRect.Width() / 2- wx / 2 - 1;
	int yPos = parentRect.Height() / 2- wy / 2-10;

	MoveWindow(xPos,yPos,wx, wy);

	// Balken allozieren und initialisieren
	_Balken=(new TGauge(this,_Titel.c_str(),GAUGE_ID,5,18,190,20,TRUE,2));
	_Balken->Create();
	_Balken->SetRange(0,100);
	_letzterWert=0;
	_Balken->SetColor(_Farbe);
	_Balken->SetValue(0);
	_Balken->MoveWindow(1,1,wx-3, wy-3);
	_Balken->Show(SW_SHOW);
}
void TWarteBox::SetValue(int value) {

	// fals sich der darzustellende Wert verndert hat,
	// Balken neuzeichnen

	if (value!=_letzterWert) {
		_Balken->SetValue(value);
		_Balken->Invalidate(false);
		_Balken->UpdateWindow();
		_letzterWert=value;
	}
}
TWarteBox::~TWarteBox() {

	// Balken freigeben
	delete _Balken;
}

